/* math-converter.c generated by valac 0.56.18, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <langinfo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_EQUATION_PROPERTY,
	MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkGrid parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkGridClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* _equation;
	gchar* category;
	Number* from_number;
	Number* to_number;
	GtkDropDown* category_combo;
	GtkDropDown* from_combo;
	GtkDropDown* to_combo;
	GtkTextView* from_entry;
	GtkTextView* to_entry;
	GtkPopoverMenu* from_context_menu;
	GtkPopoverMenu* to_context_menu;
	Serializer* fixed_serializer;
	GtkEventControllerKey* from_event_controller;
	GtkEventControllerKey* to_event_controller;
	gulong from_combobox_changed;
	gulong from_entry_changed;
	gulong to_entry_changed;
	GSimpleActionGroup* action_group;
	gboolean _outer_box_visible;
};

struct _Block3Data {
	int _ref_count_;
	MathConverter* self;
	GdkClipboard* clipboard;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

VALA_EXTERN GType math_converter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MathConverter, g_object_unref)
static void math_converter_popup_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void math_converter_copy_cb (MathConverter* self,
                             GSimpleAction* action,
                             GVariant* param);
static void _math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void math_converter_paste_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
VALA_EXTERN MathConverter* math_converter_new (MathEquation* equation);
VALA_EXTERN MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
static void math_converter_construct_finish (MathConverter* self);
VALA_EXTERN MathEquation* math_converter_get_equation (MathConverter* self);
static void __lambda13_ (MathConverter* self);
static void math_converter_update_visibility (MathConverter* self);
static void ___lambda13__currency_manager_updated (CurrencyManager* _sender,
                                            gpointer self);
static void math_converter_build_category_model (MathConverter* self);
static void math_converter_build_units_model (MathConverter* self);
static void math_converter_reformat_display (MathConverter* self);
static void _math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                     Serializer* serializer,
                                                                     gpointer self);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void math_converter_from_entry_changed_cb (MathConverter* self);
static void _math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                    gpointer self);
static void math_converter_to_entry_changed_cb (MathConverter* self);
static void _math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                  gpointer self);
VALA_EXTERN void math_converter_set_conversion (MathConverter* self,
                                    const gchar* unit_a,
                                    const gchar* unit_b);
static gint ____lambda14_ (MathConverter* self,
                    GObject* c1,
                    GObject* c2);
static gint _____lambda14__gcompare_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
VALA_EXTERN gchar* math_converter_get_category (MathConverter* self);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkDropDown* combo,
                                         Unit* unit);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
VALA_EXTERN void math_converter_get_conversion (MathConverter* self,
                                    Unit** from_unit,
                                    Unit** to_unit);
VALA_EXTERN void math_converter_insert_text (MathConverter* self,
                                 const gchar* text);
VALA_EXTERN void math_converter_insert_numeric_point (MathConverter* self);
VALA_EXTERN void math_converter_clear (MathConverter* self);
VALA_EXTERN void math_converter_backspace (MathConverter* self);
VALA_EXTERN void math_converter_paste (MathConverter* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda12_ (Block3Data* _data3_,
                  GObject* obj,
                  GAsyncResult* res);
static void math_converter_on_paste (MathConverter* self,
                              const gchar* text);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void math_converter_set_outer_box_visible (MathConverter* self,
                                           gboolean value);
static void math_converter_category_combobox_changed_cb (MathConverter* self);
static void _math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit** source_unit,
                                         Unit** target_unit);
static void math_converter_save_selected_units (MathConverter* self);
static void _math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void math_converter_from_entry_focus_cb (MathConverter* self);
static Number* math_converter_get_number_from_string (MathConverter* self,
                                               const gchar* str);
static void _math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void math_converter_to_entry_focus_cb (MathConverter* self);
static void _math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static gboolean math_converter_key_press_cb (MathConverter* self,
                                      GtkEventControllerKey* controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType mod_state);
static gboolean _math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void math_converter_from_entry_click_cb (MathConverter* self,
                                         GtkGestureClick* gesture,
                                         gint n_click,
                                         gdouble x,
                                         gdouble y);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void math_converter_show_context_menu (MathConverter* self,
                                       GtkTextView* entry,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void math_converter_to_entry_click_cb (MathConverter* self,
                                       GtkGestureClick* gesture,
                                       gint n_click,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
VALA_EXTERN void math_converter_swap_units (MathConverter* self);
VALA_EXTERN void math_converter_set_equation (MathConverter* self,
                                  MathEquation* value);
VALA_EXTERN gboolean math_converter_get_outer_box_visible (MathConverter* self);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void math_converter_finalize (GObject * obj);
static GType math_converter_get_type_once (void);
static void _vala_math_converter_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_math_converter_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry MATH_CONVERTER_action_entries[3] = {{"popup", _math_converter_popup_cb_gsimple_action_activate_callback}, {"copy", _math_converter_copy_cb_gsimple_action_activate_callback}, {"paste", _math_converter_paste_cb_gsimple_action_activate_callback}};

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

static void
_math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_popup_cb ((MathConverter*) self, action, parameter);
#line 296 "math-converter.c"
}

static void
_math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_copy_cb ((MathConverter*) self, action, parameter);
#line 306 "math-converter.c"
}

static void
_math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 45 "../src/math-converter.vala"
	math_converter_paste_cb ((MathConverter*) self, action, parameter);
#line 316 "math-converter.c"
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 59 "../src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 61 "../src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, "equation", equation, NULL);
#line 59 "../src/math-converter.vala"
	return self;
#line 330 "math-converter.c"
}

MathConverter*
math_converter_new (MathEquation* equation)
{
#line 59 "../src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 338 "math-converter.c"
}

static void
__lambda13_ (MathConverter* self)
{
#line 77 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 346 "math-converter.c"
}

static void
___lambda13__currency_manager_updated (CurrencyManager* _sender,
                                       gpointer self)
{
#line 76 "../src/math-converter.vala"
	__lambda13_ ((MathConverter*) self);
#line 355 "math-converter.c"
}

static void
_math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                Serializer* serializer,
                                                                gpointer self)
{
#line 84 "../src/math-converter.vala"
	math_converter_reformat_display ((MathConverter*) self);
#line 365 "math-converter.c"
}

static void
_math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 85 "../src/math-converter.vala"
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
#line 375 "math-converter.c"
}

static void
_math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                               gpointer self)
{
#line 92 "../src/math-converter.vala"
	math_converter_from_entry_changed_cb ((MathConverter*) self);
#line 384 "math-converter.c"
}

static void
_math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                             gpointer self)
{
#line 93 "../src/math-converter.vala"
	math_converter_to_entry_changed_cb ((MathConverter*) self);
#line 393 "math-converter.c"
}

static void
math_converter_construct_finish (MathConverter* self)
{
	MathEquation* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	MathEquation* _tmp3_;
	GtkDropDown* _tmp4_;
	gulong _tmp5_;
	MathEquation* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	MathEquation* _tmp15_;
	Serializer* _tmp16_;
	Serializer* _tmp17_;
	Number* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkTextView* _tmp21_;
	GtkTextBuffer* _tmp22_;
	GtkTextBuffer* _tmp23_;
	MathEquation* _tmp24_;
	Serializer* _tmp25_;
	Serializer* _tmp26_;
	Number* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GtkTextView* _tmp30_;
	GtkTextBuffer* _tmp31_;
	GtkTextBuffer* _tmp32_;
	gulong _tmp33_;
	GtkTextView* _tmp34_;
	GtkTextBuffer* _tmp35_;
	GtkTextBuffer* _tmp36_;
	gulong _tmp37_;
	MathEquation* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	MathEquation* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
#line 71 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 73 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 74 "../src/math-converter.vala"
		return;
#line 453 "math-converter.c"
	}
#line 76 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 76 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/math-converter.vala"
	g_signal_connect_object (_tmp2_, "updated", (GCallback) ___lambda13__currency_manager_updated, self, 0);
#line 76 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 80 "../src/math-converter.vala"
	math_converter_build_category_model (self);
#line 81 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 82 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 84 "../src/math-converter.vala"
	_tmp3_ = self->priv->_equation;
#line 84 "../src/math-converter.vala"
	g_signal_connect_object (_tmp3_, "display-changed", (GCallback) _math_converter_reformat_display_math_equation_display_changed, self, 0);
#line 85 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_combo;
#line 85 "../src/math-converter.vala"
	_tmp5_ = g_signal_connect_object ((GObject*) _tmp4_, "notify::selected", (GCallback) _math_converter_from_combobox_changed_cb_g_object_notify, self, 0);
#line 85 "../src/math-converter.vala"
	self->priv->from_combobox_changed = _tmp5_;
#line 86 "../src/math-converter.vala"
	_tmp6_ = self->priv->_equation;
#line 86 "../src/math-converter.vala"
	_tmp7_ = math_equation_get_accuracy (_tmp6_);
#line 86 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 86 "../src/math-converter.vala"
	_tmp9_ = serializer_new (DISPLAY_FORMAT_FIXED, 10, _tmp8_);
#line 86 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 86 "../src/math-converter.vala"
	self->priv->fixed_serializer = _tmp9_;
#line 88 "../src/math-converter.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 88 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 88 "../src/math-converter.vala"
	self->priv->from_number = _tmp10_;
#line 89 "../src/math-converter.vala"
	_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 89 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 89 "../src/math-converter.vala"
	self->priv->to_number = _tmp11_;
#line 90 "../src/math-converter.vala"
	_tmp12_ = self->priv->from_entry;
#line 90 "../src/math-converter.vala"
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
#line 90 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 90 "../src/math-converter.vala"
	_tmp15_ = self->priv->_equation;
#line 90 "../src/math-converter.vala"
	_tmp16_ = math_equation_get_serializer (_tmp15_);
#line 90 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 90 "../src/math-converter.vala"
	_tmp18_ = self->priv->from_number;
#line 90 "../src/math-converter.vala"
	_tmp19_ = serializer_to_string (_tmp17_, _tmp18_);
#line 90 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 90 "../src/math-converter.vala"
	g_object_set (_tmp14_, "text", _tmp20_, NULL);
#line 90 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 91 "../src/math-converter.vala"
	_tmp21_ = self->priv->to_entry;
#line 91 "../src/math-converter.vala"
	_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
#line 91 "../src/math-converter.vala"
	_tmp23_ = _tmp22_;
#line 91 "../src/math-converter.vala"
	_tmp24_ = self->priv->_equation;
#line 91 "../src/math-converter.vala"
	_tmp25_ = math_equation_get_serializer (_tmp24_);
#line 91 "../src/math-converter.vala"
	_tmp26_ = _tmp25_;
#line 91 "../src/math-converter.vala"
	_tmp27_ = self->priv->to_number;
#line 91 "../src/math-converter.vala"
	_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
#line 91 "../src/math-converter.vala"
	_tmp29_ = _tmp28_;
#line 91 "../src/math-converter.vala"
	g_object_set (_tmp23_, "text", _tmp29_, NULL);
#line 91 "../src/math-converter.vala"
	_g_free0 (_tmp29_);
#line 92 "../src/math-converter.vala"
	_tmp30_ = self->priv->from_entry;
#line 92 "../src/math-converter.vala"
	_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
#line 92 "../src/math-converter.vala"
	_tmp32_ = _tmp31_;
#line 92 "../src/math-converter.vala"
	_tmp33_ = g_signal_connect_object (_tmp32_, "changed", (GCallback) _math_converter_from_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 92 "../src/math-converter.vala"
	self->priv->from_entry_changed = _tmp33_;
#line 93 "../src/math-converter.vala"
	_tmp34_ = self->priv->to_entry;
#line 93 "../src/math-converter.vala"
	_tmp35_ = gtk_text_view_get_buffer (_tmp34_);
#line 93 "../src/math-converter.vala"
	_tmp36_ = _tmp35_;
#line 93 "../src/math-converter.vala"
	_tmp37_ = g_signal_connect_object (_tmp36_, "changed", (GCallback) _math_converter_to_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 93 "../src/math-converter.vala"
	self->priv->to_entry_changed = _tmp37_;
#line 95 "../src/math-converter.vala"
	_tmp38_ = self->priv->_equation;
#line 95 "../src/math-converter.vala"
	_tmp39_ = math_equation_get_source_units (_tmp38_);
#line 95 "../src/math-converter.vala"
	_tmp40_ = _tmp39_;
#line 95 "../src/math-converter.vala"
	_tmp41_ = _tmp40_;
#line 95 "../src/math-converter.vala"
	_tmp42_ = self->priv->_equation;
#line 95 "../src/math-converter.vala"
	_tmp43_ = math_equation_get_target_units (_tmp42_);
#line 95 "../src/math-converter.vala"
	_tmp44_ = _tmp43_;
#line 95 "../src/math-converter.vala"
	_tmp45_ = _tmp44_;
#line 95 "../src/math-converter.vala"
	math_converter_set_conversion (self, _tmp41_, _tmp45_);
#line 95 "../src/math-converter.vala"
	_g_free0 (_tmp45_);
#line 95 "../src/math-converter.vala"
	_g_free0 (_tmp41_);
#line 589 "math-converter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "../src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 597 "math-converter.c"
}

static gint
____lambda14_ (MathConverter* self,
               GObject* c1,
               GObject* c2)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint result;
#line 107 "../src/math-converter.vala"
	g_return_val_if_fail (c1 != NULL, 0);
#line 107 "../src/math-converter.vala"
	g_return_val_if_fail (c2 != NULL, 0);
#line 107 "../src/math-converter.vala"
	_tmp0_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c1, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c1) : NULL);
#line 107 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 107 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/math-converter.vala"
	_tmp3_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c2, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c2) : NULL);
#line 107 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 107 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 107 "../src/math-converter.vala"
	_tmp6_ = g_utf8_collate (_tmp2_, _tmp5_);
#line 107 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 107 "../src/math-converter.vala"
	_g_free0 (_tmp2_);
#line 107 "../src/math-converter.vala"
	result = _tmp6_;
#line 107 "../src/math-converter.vala"
	return result;
#line 639 "math-converter.c"
}

static gint
_____lambda14__gcompare_data_func (gconstpointer a,
                                   gconstpointer b,
                                   gpointer self)
{
	gint result;
	result = ____lambda14_ ((MathConverter*) self, (GObject*) a, (GObject*) b);
#line 107 "../src/math-converter.vala"
	return result;
#line 651 "math-converter.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 98 "../src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 659 "math-converter.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 98 "../src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 667 "math-converter.c"
}

static void
math_converter_build_category_model (MathConverter* self)
{
	GListStore* category_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GList* categories = NULL;
	UnitManager* _tmp2_;
	UnitManager* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GtkDropDown* _tmp10_;
	GtkPropertyExpression* _tmp11_;
	GtkDropDown* _tmp12_;
	GListStore* _tmp13_;
#line 98 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT_CATEGORY);
#line 99 "../src/math-converter.vala"
	category_model = _tmp0_;
#line 100 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT_CATEGORY, NULL, "display_name");
#line 100 "../src/math-converter.vala"
	expression = _tmp1_;
#line 104 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_default ();
#line 104 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_categories (_tmp3_);
#line 104 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 104 "../src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 104 "../src/math-converter.vala"
	categories = _tmp5_;
#line 105 "../src/math-converter.vala"
	_tmp6_ = categories;
#line 711 "math-converter.c"
	{
		GList* category_collection = NULL;
		GList* category_it = NULL;
#line 105 "../src/math-converter.vala"
		category_collection = _tmp6_;
#line 105 "../src/math-converter.vala"
		for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 719 "math-converter.c"
			UnitCategory* _tmp7_;
			UnitCategory* category = NULL;
#line 105 "../src/math-converter.vala"
			_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 105 "../src/math-converter.vala"
			category = _tmp7_;
#line 726 "math-converter.c"
			{
				GListStore* _tmp8_;
				UnitCategory* _tmp9_;
#line 107 "../src/math-converter.vala"
				_tmp8_ = category_model;
#line 107 "../src/math-converter.vala"
				_tmp9_ = category;
#line 107 "../src/math-converter.vala"
				g_list_store_insert_sorted (_tmp8_, (GObject*) _tmp9_, _____lambda14__gcompare_data_func, self);
#line 105 "../src/math-converter.vala"
				_g_object_unref0 (category);
#line 738 "math-converter.c"
			}
		}
	}
#line 109 "../src/math-converter.vala"
	_tmp10_ = self->priv->category_combo;
#line 109 "../src/math-converter.vala"
	_tmp11_ = expression;
#line 109 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp10_, (GtkExpression*) _tmp11_);
#line 110 "../src/math-converter.vala"
	_tmp12_ = self->priv->category_combo;
#line 110 "../src/math-converter.vala"
	_tmp13_ = category_model;
#line 110 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp12_, (GListModel*) _tmp13_);
#line 98 "../src/math-converter.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 98 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 98 "../src/math-converter.vala"
	_g_object_unref0 (category_model);
#line 760 "math-converter.c"
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 113 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 115 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 116 "../src/math-converter.vala"
		return;
#line 778 "math-converter.c"
	}
#line 117 "../src/math-converter.vala"
	_tmp1_ = g_strdup (category);
#line 117 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 117 "../src/math-converter.vala"
	self->priv->category = _tmp1_;
#line 118 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 118 "../src/math-converter.vala"
	if (_tmp2_ != NULL) {
#line 790 "math-converter.c"
		UnitCategory* unit_category = NULL;
		UnitManager* _tmp3_;
		UnitManager* _tmp4_;
		const gchar* _tmp5_;
		UnitCategory* _tmp6_;
		UnitCategory* _tmp7_;
		guint position = 0U;
		GListStore* model = NULL;
		GtkDropDown* _tmp8_;
		GListModel* _tmp9_;
		GListStore* _tmp10_;
		GListStore* _tmp11_;
		UnitCategory* _tmp12_;
		guint _tmp13_ = 0U;
		GtkDropDown* _tmp14_;
#line 120 "../src/math-converter.vala"
		_tmp3_ = unit_manager_get_default ();
#line 120 "../src/math-converter.vala"
		_tmp4_ = _tmp3_;
#line 120 "../src/math-converter.vala"
		_tmp5_ = self->priv->category;
#line 120 "../src/math-converter.vala"
		_tmp6_ = unit_manager_get_category (_tmp4_, _tmp5_);
#line 120 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 120 "../src/math-converter.vala"
		_g_object_unref0 (_tmp4_);
#line 120 "../src/math-converter.vala"
		unit_category = _tmp7_;
#line 121 "../src/math-converter.vala"
		position = (guint) 0;
#line 122 "../src/math-converter.vala"
		_tmp8_ = self->priv->category_combo;
#line 122 "../src/math-converter.vala"
		_tmp9_ = gtk_drop_down_get_model (_tmp8_);
#line 122 "../src/math-converter.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, g_list_store_get_type ()) ? ((GListStore*) _tmp9_) : NULL);
#line 122 "../src/math-converter.vala"
		model = _tmp10_;
#line 123 "../src/math-converter.vala"
		_tmp11_ = model;
#line 123 "../src/math-converter.vala"
		_tmp12_ = unit_category;
#line 123 "../src/math-converter.vala"
		g_list_store_find (_tmp11_, (GObject*) _tmp12_, &_tmp13_);
#line 123 "../src/math-converter.vala"
		position = _tmp13_;
#line 124 "../src/math-converter.vala"
		_tmp14_ = self->priv->category_combo;
#line 124 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp14_, position);
#line 118 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 118 "../src/math-converter.vala"
		_g_object_unref0 (unit_category);
#line 846 "math-converter.c"
	} else {
		GtkDropDown* _tmp15_;
#line 126 "../src/math-converter.vala"
		_tmp15_ = self->priv->category_combo;
#line 126 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp15_, (guint) 0);
#line 853 "math-converter.c"
	}
}

gchar*
math_converter_get_category (MathConverter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 131 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 133 "../src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 133 "../src/math-converter.vala"
	result = _tmp1_;
#line 133 "../src/math-converter.vala"
	return result;
#line 873 "math-converter.c"
}

void
math_converter_set_conversion (MathConverter* self,
                               const gchar* unit_a,
                               const gchar* unit_b)
{
	Unit* ua = NULL;
	UnitManager* _tmp0_;
	UnitManager* _tmp1_;
	Unit* _tmp2_;
	Unit* _tmp3_;
	Unit* ub = NULL;
	UnitManager* _tmp4_;
	UnitManager* _tmp5_;
	Unit* _tmp6_;
	Unit* _tmp7_;
	UnitCategory* uc = NULL;
	UnitManager* _tmp8_;
	UnitManager* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	Unit* _tmp14_;
	UnitCategory* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkDropDown* _tmp22_;
	GtkDropDown* _tmp23_;
	Unit* _tmp24_;
	GtkDropDown* _tmp25_;
	GtkDropDown* _tmp26_;
	Unit* _tmp27_;
#line 136 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/math-converter.vala"
	g_return_if_fail (unit_a != NULL);
#line 136 "../src/math-converter.vala"
	g_return_if_fail (unit_b != NULL);
#line 138 "../src/math-converter.vala"
	_tmp0_ = unit_manager_get_default ();
#line 138 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 138 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_unit_by_name (_tmp1_, unit_a);
#line 138 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 138 "../src/math-converter.vala"
	_g_object_unref0 (_tmp1_);
#line 138 "../src/math-converter.vala"
	ua = _tmp3_;
#line 139 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_default ();
#line 139 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 139 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_unit_by_name (_tmp5_, unit_b);
#line 139 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 139 "../src/math-converter.vala"
	_g_object_unref0 (_tmp5_);
#line 139 "../src/math-converter.vala"
	ub = _tmp7_;
#line 140 "../src/math-converter.vala"
	_tmp8_ = unit_manager_get_default ();
#line 140 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 140 "../src/math-converter.vala"
	_tmp10_ = unit_manager_get_category_of_unit (_tmp9_, unit_a);
#line 140 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 140 "../src/math-converter.vala"
	_g_object_unref0 (_tmp9_);
#line 140 "../src/math-converter.vala"
	uc = _tmp11_;
#line 141 "../src/math-converter.vala"
	_tmp14_ = ua;
#line 141 "../src/math-converter.vala"
	if (_tmp14_ == NULL) {
#line 141 "../src/math-converter.vala"
		_tmp13_ = TRUE;
#line 957 "math-converter.c"
	} else {
		Unit* _tmp15_;
#line 141 "../src/math-converter.vala"
		_tmp15_ = ub;
#line 141 "../src/math-converter.vala"
		_tmp13_ = _tmp15_ == NULL;
#line 964 "math-converter.c"
	}
#line 141 "../src/math-converter.vala"
	if (_tmp13_) {
#line 141 "../src/math-converter.vala"
		_tmp12_ = TRUE;
#line 970 "math-converter.c"
	} else {
		UnitCategory* _tmp16_;
#line 141 "../src/math-converter.vala"
		_tmp16_ = uc;
#line 141 "../src/math-converter.vala"
		_tmp12_ = _tmp16_ == NULL;
#line 977 "math-converter.c"
	}
#line 141 "../src/math-converter.vala"
	if (_tmp12_) {
#line 981 "math-converter.c"
		GtkDropDown* _tmp17_;
#line 143 "../src/math-converter.vala"
		_tmp17_ = self->priv->from_combo;
#line 143 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp17_, (guint) 0);
#line 144 "../src/math-converter.vala"
		_g_object_unref0 (uc);
#line 144 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 144 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 144 "../src/math-converter.vala"
		return;
#line 995 "math-converter.c"
	}
#line 147 "../src/math-converter.vala"
	_tmp18_ = uc;
#line 147 "../src/math-converter.vala"
	_tmp19_ = unit_category_get_name (_tmp18_);
#line 147 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 147 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 147 "../src/math-converter.vala"
	math_converter_set_category (self, _tmp21_);
#line 147 "../src/math-converter.vala"
	_g_free0 (_tmp21_);
#line 148 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_combo;
#line 148 "../src/math-converter.vala"
	g_signal_handler_block (_tmp22_, self->priv->from_combobox_changed);
#line 149 "../src/math-converter.vala"
	_tmp23_ = self->priv->from_combo;
#line 149 "../src/math-converter.vala"
	_tmp24_ = ua;
#line 149 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp23_, _tmp24_);
#line 150 "../src/math-converter.vala"
	_tmp25_ = self->priv->from_combo;
#line 150 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp25_, self->priv->from_combobox_changed);
#line 151 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_combo;
#line 151 "../src/math-converter.vala"
	_tmp27_ = ub;
#line 151 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp26_, _tmp27_);
#line 152 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 136 "../src/math-converter.vala"
	_g_object_unref0 (uc);
#line 136 "../src/math-converter.vala"
	_g_object_unref0 (ub);
#line 136 "../src/math-converter.vala"
	_g_object_unref0 (ua);
#line 1037 "math-converter.c"
}

void
math_converter_get_conversion (MathConverter* self,
                               Unit** from_unit,
                               Unit** to_unit)
{
	Unit* _vala_from_unit = NULL;
	Unit* _vala_to_unit = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	Unit* _tmp3_;
	GtkDropDown* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	Unit* _tmp7_;
#line 155 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 158 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 158 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 158 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT) ? ((Unit*) _tmp2_) : NULL);
#line 158 "../src/math-converter.vala"
	_g_object_unref0 (_vala_from_unit);
#line 158 "../src/math-converter.vala"
	_vala_from_unit = _tmp3_;
#line 159 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 159 "../src/math-converter.vala"
	_tmp5_ = gtk_drop_down_get_selected_item (_tmp4_);
#line 159 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 159 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, TYPE_UNIT) ? ((Unit*) _tmp6_) : NULL);
#line 159 "../src/math-converter.vala"
	_g_object_unref0 (_vala_to_unit);
#line 159 "../src/math-converter.vala"
	_vala_to_unit = _tmp7_;
#line 155 "../src/math-converter.vala"
	if (from_unit) {
#line 155 "../src/math-converter.vala"
		*from_unit = _vala_from_unit;
#line 1085 "math-converter.c"
	} else {
#line 155 "../src/math-converter.vala"
		_g_object_unref0 (_vala_from_unit);
#line 1089 "math-converter.c"
	}
#line 155 "../src/math-converter.vala"
	if (to_unit) {
#line 155 "../src/math-converter.vala"
		*to_unit = _vala_to_unit;
#line 1095 "math-converter.c"
	} else {
#line 155 "../src/math-converter.vala"
		_g_object_unref0 (_vala_to_unit);
#line 1099 "math-converter.c"
	}
}

void
math_converter_insert_text (MathConverter* self,
                            const gchar* text)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
	GtkTextView* _tmp28_;
	GtkTextBuffer* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextView* _tmp31_;
	GtkTextBuffer* _tmp32_;
	GtkTextBuffer* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
#line 162 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/math-converter.vala"
	g_return_if_fail (text != NULL);
#line 164 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 164 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 164 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 164 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1142 "math-converter.c"
		GtkTextView* _tmp4_;
#line 164 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 164 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1148 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 164 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 164 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1155 "math-converter.c"
	}
#line 164 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 164 "../src/math-converter.vala"
	entry = _tmp6_;
#line 165 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 165 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 165 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1167 "math-converter.c"
		GtkTextView* _tmp9_;
#line 166 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 166 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1173 "math-converter.c"
	}
#line 167 "../src/math-converter.vala"
	_tmp10_ = entry;
#line 167 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 167 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 167 "../src/math-converter.vala"
	g_object_get (_tmp12_, "text", &_tmp13_, NULL);
#line 167 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 167 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 167 "../src/math-converter.vala"
	_tmp16_ = g_strcmp0 (_tmp15_, "0") == 0;
#line 167 "../src/math-converter.vala"
	_g_free0 (_tmp15_);
#line 167 "../src/math-converter.vala"
	if (_tmp16_) {
#line 1193 "math-converter.c"
		GtkTextIter iter = {0};
		GtkTextView* _tmp17_;
		GtkTextBuffer* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextView* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextMark* _tmp23_;
		GtkTextIter _tmp24_ = {0};
#line 170 "../src/math-converter.vala"
		_tmp17_ = entry;
#line 170 "../src/math-converter.vala"
		_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 170 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 170 "../src/math-converter.vala"
		_tmp20_ = entry;
#line 170 "../src/math-converter.vala"
		_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 170 "../src/math-converter.vala"
		_tmp22_ = _tmp21_;
#line 170 "../src/math-converter.vala"
		_tmp23_ = gtk_text_buffer_get_insert (_tmp22_);
#line 170 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp19_, &_tmp24_, _tmp23_);
#line 170 "../src/math-converter.vala"
		iter = _tmp24_;
#line 171 "../src/math-converter.vala"
		if (gtk_text_iter_is_end (&iter)) {
#line 1223 "math-converter.c"
			GtkTextView* _tmp25_;
			GtkTextBuffer* _tmp26_;
			GtkTextBuffer* _tmp27_;
#line 172 "../src/math-converter.vala"
			_tmp25_ = entry;
#line 172 "../src/math-converter.vala"
			_tmp26_ = gtk_text_view_get_buffer (_tmp25_);
#line 172 "../src/math-converter.vala"
			_tmp27_ = _tmp26_;
#line 172 "../src/math-converter.vala"
			g_object_set (_tmp27_, "text", "", NULL);
#line 1235 "math-converter.c"
		}
	}
#line 174 "../src/math-converter.vala"
	_tmp28_ = entry;
#line 174 "../src/math-converter.vala"
	_tmp29_ = gtk_text_view_get_buffer (_tmp28_);
#line 174 "../src/math-converter.vala"
	_tmp30_ = _tmp29_;
#line 174 "../src/math-converter.vala"
	gtk_text_buffer_delete_selection (_tmp30_, TRUE, TRUE);
#line 175 "../src/math-converter.vala"
	_tmp31_ = entry;
#line 175 "../src/math-converter.vala"
	_tmp32_ = gtk_text_view_get_buffer (_tmp31_);
#line 175 "../src/math-converter.vala"
	_tmp33_ = _tmp32_;
#line 175 "../src/math-converter.vala"
	_tmp34_ = strlen (text);
#line 175 "../src/math-converter.vala"
	_tmp35_ = _tmp34_;
#line 175 "../src/math-converter.vala"
	gtk_text_buffer_insert_at_cursor (_tmp33_, text, _tmp35_);
#line 162 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1260 "math-converter.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1279 "math-converter.c"
}

void
math_converter_insert_numeric_point (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	gchar* text = NULL;
	Serializer* _tmp10_;
	gchar* _tmp11_;
	GtkTextView* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
#line 178 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 180 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 180 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 180 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1314 "math-converter.c"
		GtkTextView* _tmp4_;
#line 180 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 180 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1320 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 180 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 180 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1327 "math-converter.c"
	}
#line 180 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 180 "../src/math-converter.vala"
	entry = _tmp6_;
#line 181 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 181 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 181 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1339 "math-converter.c"
		GtkTextView* _tmp9_;
#line 182 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 182 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1345 "math-converter.c"
	}
#line 183 "../src/math-converter.vala"
	_tmp10_ = self->priv->fixed_serializer;
#line 183 "../src/math-converter.vala"
	_tmp11_ = g_unichar_to_string (serializer_get_radix (_tmp10_));
#line 183 "../src/math-converter.vala"
	text = _tmp11_;
#line 184 "../src/math-converter.vala"
	_tmp12_ = entry;
#line 184 "../src/math-converter.vala"
	_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
#line 184 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 184 "../src/math-converter.vala"
	gtk_text_buffer_delete_selection (_tmp14_, TRUE, TRUE);
#line 185 "../src/math-converter.vala"
	_tmp15_ = entry;
#line 185 "../src/math-converter.vala"
	_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
#line 185 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 185 "../src/math-converter.vala"
	_tmp18_ = strlen (text);
#line 185 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 185 "../src/math-converter.vala"
	gtk_text_buffer_insert_at_cursor (_tmp17_, text, _tmp19_);
#line 178 "../src/math-converter.vala"
	_g_free0 (text);
#line 178 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1377 "math-converter.c"
}

void
math_converter_clear (MathConverter* self)
{
	GtkTextView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 188 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 190 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp0_, "has-focus", &_tmp1_, NULL);
#line 190 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 190 "../src/math-converter.vala"
	if (_tmp2_) {
#line 1396 "math-converter.c"
		GtkTextView* _tmp3_;
		GtkTextBuffer* _tmp4_;
		GtkTextBuffer* _tmp5_;
#line 191 "../src/math-converter.vala"
		_tmp3_ = self->priv->from_entry;
#line 191 "../src/math-converter.vala"
		_tmp4_ = gtk_text_view_get_buffer (_tmp3_);
#line 191 "../src/math-converter.vala"
		_tmp5_ = _tmp4_;
#line 191 "../src/math-converter.vala"
		g_object_set (_tmp5_, "text", "0", NULL);
#line 1408 "math-converter.c"
	} else {
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		MathEquation* _tmp9_;
		Serializer* _tmp10_;
		Serializer* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 193 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 193 "../src/math-converter.vala"
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
#line 193 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 193 "../src/math-converter.vala"
		_tmp9_ = self->priv->_equation;
#line 193 "../src/math-converter.vala"
		_tmp10_ = math_equation_get_serializer (_tmp9_);
#line 193 "../src/math-converter.vala"
		_tmp11_ = _tmp10_;
#line 193 "../src/math-converter.vala"
		_tmp12_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 193 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 193 "../src/math-converter.vala"
		_tmp14_ = serializer_to_string (_tmp11_, _tmp13_);
#line 193 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 193 "../src/math-converter.vala"
		g_object_set (_tmp8_, "text", _tmp15_, NULL);
#line 193 "../src/math-converter.vala"
		_g_free0 (_tmp15_);
#line 193 "../src/math-converter.vala"
		_g_object_unref0 (_tmp13_);
#line 1446 "math-converter.c"
	}
}

void
math_converter_backspace (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 196 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 198 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 198 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 198 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1476 "math-converter.c"
		GtkTextView* _tmp4_;
#line 198 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 198 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1482 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 198 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 198 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1489 "math-converter.c"
	}
#line 198 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 198 "../src/math-converter.vala"
	entry = _tmp6_;
#line 199 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 199 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 199 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1501 "math-converter.c"
		GtkTextView* _tmp9_;
#line 200 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 200 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1507 "math-converter.c"
	}
#line 201 "../src/math-converter.vala"
	_tmp10_ = entry;
#line 201 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 201 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 201 "../src/math-converter.vala"
	_tmp13_ = gtk_text_buffer_get_has_selection (_tmp12_);
#line 201 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 201 "../src/math-converter.vala"
	if (_tmp14_) {
#line 1521 "math-converter.c"
		GtkTextView* _tmp15_;
		GtkTextBuffer* _tmp16_;
		GtkTextBuffer* _tmp17_;
#line 203 "../src/math-converter.vala"
		_tmp15_ = entry;
#line 203 "../src/math-converter.vala"
		_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
#line 203 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 203 "../src/math-converter.vala"
		gtk_text_buffer_delete_selection (_tmp17_, TRUE, TRUE);
#line 1533 "math-converter.c"
	} else {
		GtkTextIter iter = {0};
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextView* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextMark* _tmp24_;
		GtkTextIter _tmp25_ = {0};
		GtkTextView* _tmp26_;
		GtkTextBuffer* _tmp27_;
		GtkTextBuffer* _tmp28_;
#line 208 "../src/math-converter.vala"
		_tmp18_ = entry;
#line 208 "../src/math-converter.vala"
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
#line 208 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 208 "../src/math-converter.vala"
		_tmp21_ = entry;
#line 208 "../src/math-converter.vala"
		_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
#line 208 "../src/math-converter.vala"
		_tmp23_ = _tmp22_;
#line 208 "../src/math-converter.vala"
		_tmp24_ = gtk_text_buffer_get_insert (_tmp23_);
#line 208 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp20_, &_tmp25_, _tmp24_);
#line 208 "../src/math-converter.vala"
		iter = _tmp25_;
#line 209 "../src/math-converter.vala"
		_tmp26_ = entry;
#line 209 "../src/math-converter.vala"
		_tmp27_ = gtk_text_view_get_buffer (_tmp26_);
#line 209 "../src/math-converter.vala"
		_tmp28_ = _tmp27_;
#line 209 "../src/math-converter.vala"
		gtk_text_buffer_backspace (_tmp28_, &iter, TRUE, TRUE);
#line 1573 "math-converter.c"
	}
#line 196 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1577 "math-converter.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 213 "../src/math-converter.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 213 "../src/math-converter.vala"
	return _data3_;
#line 1587 "math-converter.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 213 "../src/math-converter.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1597 "math-converter.c"
		MathConverter* self;
#line 213 "../src/math-converter.vala"
		self = _data3_->self;
#line 213 "../src/math-converter.vala"
		_g_object_unref0 (_data3_->clipboard);
#line 213 "../src/math-converter.vala"
		_g_object_unref0 (self);
#line 213 "../src/math-converter.vala"
		g_slice_free (Block3Data, _data3_);
#line 1607 "math-converter.c"
	}
}

static void
__lambda12_ (Block3Data* _data3_,
             GObject* obj,
             GAsyncResult* res)
{
	MathConverter* self;
	GError* _inner_error0_ = NULL;
#line 218 "../src/math-converter.vala"
	self = _data3_->self;
#line 218 "../src/math-converter.vala"
	g_return_if_fail (res != NULL);
#line 1622 "math-converter.c"
	{
		gchar* _tmp0_ = NULL;
		GdkClipboard* _tmp1_;
		gchar* _tmp2_;
#line 220 "../src/math-converter.vala"
		_tmp1_ = _data3_->clipboard;
#line 220 "../src/math-converter.vala"
		_tmp2_ = gdk_clipboard_read_text_finish (_tmp1_, res, &_inner_error0_);
#line 220 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 220 "../src/math-converter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1635 "math-converter.c"
			goto __catch0_g_error;
		}
#line 220 "../src/math-converter.vala"
		math_converter_on_paste (self, _tmp0_);
#line 219 "../src/math-converter.vala"
		_g_free0 (_tmp0_);
#line 1642 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 219 "../src/math-converter.vala"
		err = _inner_error0_;
#line 219 "../src/math-converter.vala"
		_inner_error0_ = NULL;
#line 222 "../src/math-converter.vala"
		_tmp3_ = err;
#line 222 "../src/math-converter.vala"
		_tmp4_ = _tmp3_->message;
#line 222 "../src/math-converter.vala"
		g_print ("%s", _tmp4_);
#line 219 "../src/math-converter.vala"
		_g_error_free0 (err);
#line 1662 "math-converter.c"
	}
	__finally0:
#line 219 "../src/math-converter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/math-converter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 219 "../src/math-converter.vala"
		g_clear_error (&_inner_error0_);
#line 219 "../src/math-converter.vala"
		return;
#line 1673 "math-converter.c"
	}
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 218 "../src/math-converter.vala"
	__lambda12_ (self, source_object, res);
#line 218 "../src/math-converter.vala"
	block3_data_unref (self);
#line 1686 "math-converter.c"
}

void
math_converter_paste (MathConverter* self)
{
	Block3Data* _data3_;
	gboolean _tmp0_ = FALSE;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GdkDisplay* _tmp7_;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
	GdkClipboard* _tmp10_;
#line 213 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/math-converter.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 213 "../src/math-converter.vala"
	_data3_->_ref_count_ = 1;
#line 213 "../src/math-converter.vala"
	_data3_->self = g_object_ref (self);
#line 215 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 215 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 215 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 215 "../src/math-converter.vala"
	if (!_tmp3_) {
#line 1717 "math-converter.c"
		GtkTextView* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 215 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 215 "../src/math-converter.vala"
		g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 215 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 215 "../src/math-converter.vala"
		_tmp0_ = !_tmp6_;
#line 1729 "math-converter.c"
	} else {
#line 215 "../src/math-converter.vala"
		_tmp0_ = FALSE;
#line 1733 "math-converter.c"
	}
#line 215 "../src/math-converter.vala"
	if (_tmp0_) {
#line 216 "../src/math-converter.vala"
		block3_data_unref (_data3_);
#line 216 "../src/math-converter.vala"
		_data3_ = NULL;
#line 216 "../src/math-converter.vala"
		return;
#line 1743 "math-converter.c"
	}
#line 217 "../src/math-converter.vala"
	_tmp7_ = gdk_display_get_default ();
#line 217 "../src/math-converter.vala"
	_tmp8_ = gdk_display_get_clipboard (_tmp7_);
#line 217 "../src/math-converter.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 217 "../src/math-converter.vala"
	_data3_->clipboard = _tmp9_;
#line 218 "../src/math-converter.vala"
	_tmp10_ = _data3_->clipboard;
#line 218 "../src/math-converter.vala"
	gdk_clipboard_read_text_async (_tmp10_, NULL, ___lambda12__gasync_ready_callback, block3_data_ref (_data3_));
#line 213 "../src/math-converter.vala"
	block3_data_unref (_data3_);
#line 213 "../src/math-converter.vala"
	_data3_ = NULL;
#line 1761 "math-converter.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1422 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1423 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1424 "glib-2.0.vapi"
	result = _result_;
#line 1424 "glib-2.0.vapi"
	return result;
#line 1786 "math-converter.c"
}

static void
math_converter_on_paste (MathConverter* self,
                         const gchar* text)
{
#line 227 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/math-converter.vala"
	if (text != NULL) {
#line 1797 "math-converter.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 231 "../src/math-converter.vala"
		_tmp0_ = string_delimit (text, "\n", ' ');
#line 231 "../src/math-converter.vala"
		_tmp1_ = _tmp0_;
#line 231 "../src/math-converter.vala"
		math_converter_insert_text (self, _tmp1_);
#line 231 "../src/math-converter.vala"
		_g_free0 (_tmp1_);
#line 1808 "math-converter.c"
	}
}

static void
math_converter_update_visibility (MathConverter* self)
{
	const gchar* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 234 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 236 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, "currency") != 0) {
#line 237 "../src/math-converter.vala"
		math_converter_set_outer_box_visible (self, TRUE);
#line 238 "../src/math-converter.vala"
		return;
#line 1830 "math-converter.c"
	}
#line 241 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 241 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/math-converter.vala"
	_tmp3_ = currency_manager_get_loaded (_tmp2_);
#line 241 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 241 "../src/math-converter.vala"
	math_converter_set_outer_box_visible (self, _tmp4_);
#line 241 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 1844 "math-converter.c"
}

static void
math_converter_build_units_model (MathConverter* self)
{
	GListStore* unit_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GtkDropDown* _tmp2_;
	GtkPropertyExpression* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkPropertyExpression* _tmp5_;
	UnitCategory* c = NULL;
	UnitManager* _tmp6_;
	UnitManager* _tmp7_;
	const gchar* _tmp8_;
	UnitCategory* _tmp9_;
	UnitCategory* _tmp10_;
	UnitCategory* _tmp11_;
	GList* _tmp12_;
	guint model_size = 0U;
	GListStore* _tmp16_;
	GtkDropDown* _tmp17_;
	GListStore* _tmp18_;
	GtkDropDown* _tmp19_;
	GtkDropDown* _tmp20_;
	GListStore* _tmp21_;
	GtkDropDown* _tmp22_;
#line 245 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT);
#line 247 "../src/math-converter.vala"
	unit_model = _tmp0_;
#line 249 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "display_name");
#line 249 "../src/math-converter.vala"
	expression = _tmp1_;
#line 252 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 252 "../src/math-converter.vala"
	_tmp3_ = expression;
#line 252 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp2_, (GtkExpression*) _tmp3_);
#line 253 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_combo;
#line 253 "../src/math-converter.vala"
	_tmp5_ = expression;
#line 253 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp4_, (GtkExpression*) _tmp5_);
#line 255 "../src/math-converter.vala"
	_tmp6_ = unit_manager_get_default ();
#line 255 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 255 "../src/math-converter.vala"
	_tmp8_ = self->priv->category;
#line 255 "../src/math-converter.vala"
	_tmp9_ = unit_manager_get_category (_tmp7_, _tmp8_);
#line 255 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 255 "../src/math-converter.vala"
	_g_object_unref0 (_tmp7_);
#line 255 "../src/math-converter.vala"
	c = _tmp10_;
#line 256 "../src/math-converter.vala"
	_tmp11_ = c;
#line 256 "../src/math-converter.vala"
	_tmp12_ = unit_category_get_units (_tmp11_);
#line 1914 "math-converter.c"
	{
		GList* unit_collection = NULL;
		GList* unit_it = NULL;
#line 256 "../src/math-converter.vala"
		unit_collection = _tmp12_;
#line 256 "../src/math-converter.vala"
		for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 1922 "math-converter.c"
			Unit* _tmp13_;
			Unit* unit = NULL;
#line 256 "../src/math-converter.vala"
			_tmp13_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 256 "../src/math-converter.vala"
			unit = _tmp13_;
#line 1929 "math-converter.c"
			{
				GListStore* _tmp14_;
				Unit* _tmp15_;
#line 258 "../src/math-converter.vala"
				_tmp14_ = unit_model;
#line 258 "../src/math-converter.vala"
				_tmp15_ = unit;
#line 258 "../src/math-converter.vala"
				g_list_store_append (_tmp14_, (GObject*) _tmp15_);
#line 256 "../src/math-converter.vala"
				_g_object_unref0 (unit);
#line 1941 "math-converter.c"
			}
		}
	}
#line 261 "../src/math-converter.vala"
	_tmp16_ = unit_model;
#line 261 "../src/math-converter.vala"
	model_size = g_list_model_get_n_items ((GListModel*) _tmp16_);
#line 262 "../src/math-converter.vala"
	_tmp17_ = self->priv->to_combo;
#line 262 "../src/math-converter.vala"
	_tmp18_ = unit_model;
#line 262 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp17_, (GListModel*) _tmp18_);
#line 263 "../src/math-converter.vala"
	_tmp19_ = self->priv->to_combo;
#line 263 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp19_, model_size > ((guint) 10));
#line 264 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_combo;
#line 264 "../src/math-converter.vala"
	_tmp21_ = unit_model;
#line 264 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp20_, (GListModel*) _tmp21_);
#line 265 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_combo;
#line 265 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp22_, model_size > ((guint) 10));
#line 245 "../src/math-converter.vala"
	_g_object_unref0 (c);
#line 245 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 245 "../src/math-converter.vala"
	_g_object_unref0 (unit_model);
#line 1975 "math-converter.c"
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkDropDown* combo,
                                Unit* unit)
{
	guint position = 0U;
	GListStore* model = NULL;
	GListModel* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	guint _tmp3_ = 0U;
	gboolean result;
#line 268 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 268 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 270 "../src/math-converter.vala"
	position = (guint) 0;
#line 271 "../src/math-converter.vala"
	_tmp0_ = gtk_drop_down_get_model (combo);
#line 271 "../src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ()) ? ((GListStore*) _tmp0_) : NULL);
#line 271 "../src/math-converter.vala"
	model = _tmp1_;
#line 272 "../src/math-converter.vala"
	_tmp2_ = model;
#line 272 "../src/math-converter.vala"
	g_list_store_find (_tmp2_, (GObject*) unit, &_tmp3_);
#line 272 "../src/math-converter.vala"
	position = _tmp3_;
#line 273 "../src/math-converter.vala"
	if (position == ((guint) -1)) {
#line 274 "../src/math-converter.vala"
		result = FALSE;
#line 274 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 274 "../src/math-converter.vala"
		return result;
#line 2018 "math-converter.c"
	}
#line 275 "../src/math-converter.vala"
	gtk_drop_down_set_selected (combo, position);
#line 276 "../src/math-converter.vala"
	result = TRUE;
#line 276 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 276 "../src/math-converter.vala"
	return result;
#line 2028 "math-converter.c"
}

static void
math_converter_category_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	UnitCategory* _tmp3_;
	UnitCategory* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* source_currency = NULL;
	gchar* _tmp8_;
	gchar* target_currency = NULL;
	gchar* _tmp9_;
	MathEquation* _tmp10_;
	UnitCategory* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
#line 280 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/math-converter.vala"
	_tmp0_ = self->priv->category_combo;
#line 282 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 282 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 282 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp2_) : NULL);
#line 282 "../src/math-converter.vala"
	category = _tmp3_;
#line 284 "../src/math-converter.vala"
	_tmp4_ = category;
#line 284 "../src/math-converter.vala"
	_tmp5_ = unit_category_get_name (_tmp4_);
#line 284 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 284 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 284 "../src/math-converter.vala"
	self->priv->category = _tmp6_;
#line 286 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 287 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 2078 "math-converter.c"
		GtkDropDown* _tmp7_;
#line 288 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_combo;
#line 288 "../src/math-converter.vala"
		g_signal_handler_block (_tmp7_, self->priv->from_combobox_changed);
#line 2084 "math-converter.c"
	}
#line 289 "../src/math-converter.vala"
	_tmp8_ = g_strdup ("");
#line 289 "../src/math-converter.vala"
	source_currency = _tmp8_;
#line 289 "../src/math-converter.vala"
	_tmp9_ = g_strdup ("");
#line 289 "../src/math-converter.vala"
	target_currency = _tmp9_;
#line 290 "../src/math-converter.vala"
	_tmp10_ = self->priv->_equation;
#line 290 "../src/math-converter.vala"
	if (_tmp10_ != NULL) {
#line 2098 "math-converter.c"
		MathEquation* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MathEquation* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 292 "../src/math-converter.vala"
		_tmp11_ = self->priv->_equation;
#line 292 "../src/math-converter.vala"
		_tmp12_ = math_equation_get_source_currency (_tmp11_);
#line 292 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 292 "../src/math-converter.vala"
		_g_free0 (source_currency);
#line 292 "../src/math-converter.vala"
		source_currency = _tmp13_;
#line 293 "../src/math-converter.vala"
		_tmp14_ = self->priv->_equation;
#line 293 "../src/math-converter.vala"
		_tmp15_ = math_equation_get_target_currency (_tmp14_);
#line 293 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 293 "../src/math-converter.vala"
		_g_free0 (target_currency);
#line 293 "../src/math-converter.vala"
		target_currency = _tmp16_;
#line 2125 "math-converter.c"
	}
#line 295 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 296 "../src/math-converter.vala"
	_tmp17_ = category;
#line 296 "../src/math-converter.vala"
	_tmp18_ = unit_category_get_name (_tmp17_);
#line 296 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 296 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 296 "../src/math-converter.vala"
	_tmp21_ = g_strcmp0 (_tmp20_, "currency") != 0;
#line 296 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 296 "../src/math-converter.vala"
	if (_tmp21_) {
#line 2143 "math-converter.c"
		GtkDropDown* _tmp22_;
#line 298 "../src/math-converter.vala"
		_tmp22_ = self->priv->from_combo;
#line 298 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp22_, (guint) 0);
#line 2149 "math-converter.c"
	} else {
		Unit* ua = NULL;
		UnitManager* _tmp23_;
		UnitManager* _tmp24_;
		const gchar* _tmp25_;
		Unit* _tmp26_;
		Unit* _tmp27_;
		Unit* ub = NULL;
		UnitManager* _tmp28_;
		UnitManager* _tmp29_;
		const gchar* _tmp30_;
		Unit* _tmp31_;
		Unit* _tmp32_;
		gboolean _tmp33_ = FALSE;
		Unit* _tmp34_;
#line 302 "../src/math-converter.vala"
		_tmp23_ = unit_manager_get_default ();
#line 302 "../src/math-converter.vala"
		_tmp24_ = _tmp23_;
#line 302 "../src/math-converter.vala"
		_tmp25_ = source_currency;
#line 302 "../src/math-converter.vala"
		_tmp26_ = unit_manager_get_unit_by_name (_tmp24_, _tmp25_);
#line 302 "../src/math-converter.vala"
		_tmp27_ = _tmp26_;
#line 302 "../src/math-converter.vala"
		_g_object_unref0 (_tmp24_);
#line 302 "../src/math-converter.vala"
		ua = _tmp27_;
#line 303 "../src/math-converter.vala"
		_tmp28_ = unit_manager_get_default ();
#line 303 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 303 "../src/math-converter.vala"
		_tmp30_ = target_currency;
#line 303 "../src/math-converter.vala"
		_tmp31_ = unit_manager_get_unit_by_name (_tmp29_, _tmp30_);
#line 303 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 303 "../src/math-converter.vala"
		_g_object_unref0 (_tmp29_);
#line 303 "../src/math-converter.vala"
		ub = _tmp32_;
#line 304 "../src/math-converter.vala"
		_tmp34_ = ua;
#line 304 "../src/math-converter.vala"
		if (_tmp34_ == NULL) {
#line 304 "../src/math-converter.vala"
			_tmp33_ = TRUE;
#line 2199 "math-converter.c"
		} else {
			Unit* _tmp35_;
#line 304 "../src/math-converter.vala"
			_tmp35_ = ub;
#line 304 "../src/math-converter.vala"
			_tmp33_ = _tmp35_ == NULL;
#line 2206 "math-converter.c"
		}
#line 304 "../src/math-converter.vala"
		if (_tmp33_) {
#line 2210 "math-converter.c"
			GtkDropDown* _tmp36_;
#line 306 "../src/math-converter.vala"
			_tmp36_ = self->priv->from_combo;
#line 306 "../src/math-converter.vala"
			gtk_drop_down_set_selected (_tmp36_, (guint) 0);
#line 2216 "math-converter.c"
		} else {
			GtkDropDown* _tmp37_;
			Unit* _tmp38_;
			GtkDropDown* _tmp39_;
			Unit* _tmp40_;
#line 310 "../src/math-converter.vala"
			_tmp37_ = self->priv->from_combo;
#line 310 "../src/math-converter.vala"
			_tmp38_ = ua;
#line 310 "../src/math-converter.vala"
			math_converter_set_active_unit (self, _tmp37_, _tmp38_);
#line 311 "../src/math-converter.vala"
			_tmp39_ = self->priv->to_combo;
#line 311 "../src/math-converter.vala"
			_tmp40_ = ub;
#line 311 "../src/math-converter.vala"
			math_converter_set_active_unit (self, _tmp39_, _tmp40_);
#line 2234 "math-converter.c"
		}
#line 296 "../src/math-converter.vala"
		_g_object_unref0 (ub);
#line 296 "../src/math-converter.vala"
		_g_object_unref0 (ua);
#line 2240 "math-converter.c"
	}
#line 314 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 2244 "math-converter.c"
		GtkDropDown* _tmp41_;
#line 315 "../src/math-converter.vala"
		_tmp41_ = self->priv->from_combo;
#line 315 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp41_, self->priv->from_combobox_changed);
#line 2250 "math-converter.c"
	}
#line 316 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 317 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL], 0);
#line 280 "../src/math-converter.vala"
	_g_free0 (target_currency);
#line 280 "../src/math-converter.vala"
	_g_free0 (source_currency);
#line 280 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 2262 "math-converter.c"
}

static void
_math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_category_combobox_changed_cb ((MathConverter*) self);
#line 2272 "math-converter.c"
}

static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	MathEquation* _tmp13_;
	Serializer* _tmp14_;
	Serializer* _tmp15_;
	Number* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkTextView* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextBuffer* _tmp21_;
#line 320 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_number;
#line 322 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 323 "../src/math-converter.vala"
		return;
#line 2309 "math-converter.c"
	}
#line 325 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_number;
#line 325 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 325 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 325 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 325 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 325 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 325 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 325 "../src/math-converter.vala"
	self->priv->from_number = _tmp4_;
#line 326 "../src/math-converter.vala"
	_tmp5_ = self->priv->from_number;
#line 326 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 2331 "math-converter.c"
		Number* _tmp6_;
#line 327 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 327 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 327 "../src/math-converter.vala"
		self->priv->from_number = _tmp6_;
#line 2339 "math-converter.c"
	}
#line 328 "../src/math-converter.vala"
	_tmp7_ = self->priv->from_entry;
#line 328 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 328 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 328 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->from_entry_changed);
#line 329 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_entry;
#line 329 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 329 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 329 "../src/math-converter.vala"
	_tmp13_ = self->priv->_equation;
#line 329 "../src/math-converter.vala"
	_tmp14_ = math_equation_get_serializer (_tmp13_);
#line 329 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 329 "../src/math-converter.vala"
	_tmp16_ = self->priv->from_number;
#line 329 "../src/math-converter.vala"
	_tmp17_ = serializer_to_string (_tmp15_, _tmp16_);
#line 329 "../src/math-converter.vala"
	_tmp18_ = _tmp17_;
#line 329 "../src/math-converter.vala"
	g_object_set (_tmp12_, "text", _tmp18_, NULL);
#line 329 "../src/math-converter.vala"
	_g_free0 (_tmp18_);
#line 330 "../src/math-converter.vala"
	_tmp19_ = self->priv->from_entry;
#line 330 "../src/math-converter.vala"
	_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
#line 330 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 330 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp21_, self->priv->from_entry_changed);
#line 331 "../src/math-converter.vala"
	math_converter_save_selected_units (self);
#line 320 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 320 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 2385 "math-converter.c"
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
#line 335 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_number;
#line 337 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 338 "../src/math-converter.vala"
		return;
#line 2416 "math-converter.c"
	}
#line 340 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_number;
#line 340 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 340 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 340 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 340 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 340 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 340 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 340 "../src/math-converter.vala"
	self->priv->to_number = _tmp4_;
#line 341 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_number;
#line 341 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 2438 "math-converter.c"
		Number* _tmp6_;
#line 342 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 342 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 342 "../src/math-converter.vala"
		self->priv->to_number = _tmp6_;
#line 2446 "math-converter.c"
	}
#line 343 "../src/math-converter.vala"
	_tmp7_ = self->priv->to_entry;
#line 343 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 343 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 343 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->to_entry_changed);
#line 344 "../src/math-converter.vala"
	_tmp10_ = self->priv->to_entry;
#line 344 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp10_, "has-focus", &_tmp11_, NULL);
#line 344 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 344 "../src/math-converter.vala"
	if (_tmp12_) {
#line 2464 "math-converter.c"
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		Serializer* _tmp16_;
		Number* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 345 "../src/math-converter.vala"
		_tmp13_ = self->priv->to_entry;
#line 345 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 345 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 345 "../src/math-converter.vala"
		_tmp16_ = self->priv->fixed_serializer;
#line 345 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_number;
#line 345 "../src/math-converter.vala"
		_tmp18_ = serializer_to_string (_tmp16_, _tmp17_);
#line 345 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 345 "../src/math-converter.vala"
		g_object_set (_tmp15_, "text", _tmp19_, NULL);
#line 345 "../src/math-converter.vala"
		_g_free0 (_tmp19_);
#line 2490 "math-converter.c"
	} else {
		GtkTextView* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextBuffer* _tmp22_;
		MathEquation* _tmp23_;
		Serializer* _tmp24_;
		Serializer* _tmp25_;
		Number* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 347 "../src/math-converter.vala"
		_tmp20_ = self->priv->to_entry;
#line 347 "../src/math-converter.vala"
		_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 347 "../src/math-converter.vala"
		_tmp22_ = _tmp21_;
#line 347 "../src/math-converter.vala"
		_tmp23_ = self->priv->_equation;
#line 347 "../src/math-converter.vala"
		_tmp24_ = math_equation_get_serializer (_tmp23_);
#line 347 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 347 "../src/math-converter.vala"
		_tmp26_ = self->priv->to_number;
#line 347 "../src/math-converter.vala"
		_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
#line 347 "../src/math-converter.vala"
		_tmp28_ = _tmp27_;
#line 347 "../src/math-converter.vala"
		g_object_set (_tmp22_, "text", _tmp28_, NULL);
#line 347 "../src/math-converter.vala"
		_g_free0 (_tmp28_);
#line 2523 "math-converter.c"
	}
#line 348 "../src/math-converter.vala"
	_tmp29_ = self->priv->to_entry;
#line 348 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 348 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 348 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp31_, self->priv->to_entry_changed);
#line 349 "../src/math-converter.vala"
	math_converter_save_selected_units (self);
#line 335 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 335 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 2539 "math-converter.c"
}

static void
_math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 2549 "math-converter.c"
}

static void
math_converter_save_selected_units (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	const gchar* _tmp2_;
	MathEquation* _tmp13_;
	Unit* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	MathEquation* _tmp18_;
	Unit* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 352 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
#line 355 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 355 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 355 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 355 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 356 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 356 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp2_, "currency") == 0) {
#line 2586 "math-converter.c"
		MathEquation* _tmp3_;
		Unit* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		MathEquation* _tmp8_;
		Unit* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 358 "../src/math-converter.vala"
		_tmp3_ = self->priv->_equation;
#line 358 "../src/math-converter.vala"
		_tmp4_ = from_unit;
#line 358 "../src/math-converter.vala"
		_tmp5_ = unit_get_name (_tmp4_);
#line 358 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 358 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 358 "../src/math-converter.vala"
		math_equation_set_source_currency (_tmp3_, _tmp7_);
#line 358 "../src/math-converter.vala"
		_g_free0 (_tmp7_);
#line 359 "../src/math-converter.vala"
		_tmp8_ = self->priv->_equation;
#line 359 "../src/math-converter.vala"
		_tmp9_ = to_unit;
#line 359 "../src/math-converter.vala"
		_tmp10_ = unit_get_name (_tmp9_);
#line 359 "../src/math-converter.vala"
		_tmp11_ = _tmp10_;
#line 359 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 359 "../src/math-converter.vala"
		math_equation_set_target_currency (_tmp8_, _tmp12_);
#line 359 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 2625 "math-converter.c"
	}
#line 361 "../src/math-converter.vala"
	_tmp13_ = self->priv->_equation;
#line 361 "../src/math-converter.vala"
	_tmp14_ = from_unit;
#line 361 "../src/math-converter.vala"
	_tmp15_ = unit_get_name (_tmp14_);
#line 361 "../src/math-converter.vala"
	_tmp16_ = _tmp15_;
#line 361 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 361 "../src/math-converter.vala"
	math_equation_set_source_units (_tmp13_, _tmp17_);
#line 361 "../src/math-converter.vala"
	_g_free0 (_tmp17_);
#line 362 "../src/math-converter.vala"
	_tmp18_ = self->priv->_equation;
#line 362 "../src/math-converter.vala"
	_tmp19_ = to_unit;
#line 362 "../src/math-converter.vala"
	_tmp20_ = unit_get_name (_tmp19_);
#line 362 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 362 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 362 "../src/math-converter.vala"
	math_equation_set_target_units (_tmp18_, _tmp22_);
#line 362 "../src/math-converter.vala"
	_g_free0 (_tmp22_);
#line 352 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 352 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 2659 "math-converter.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2680 "math-converter.c"
}

static void
math_converter_from_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
#line 366 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 368 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 368 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 368 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->from_entry_changed);
#line 369 "../src/math-converter.vala"
	_tmp3_ = self->priv->from_entry;
#line 369 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 369 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 369 "../src/math-converter.vala"
	if (_tmp5_) {
#line 2713 "math-converter.c"
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 371 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 371 "../src/math-converter.vala"
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
#line 371 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 371 "../src/math-converter.vala"
		_tmp9_ = self->priv->fixed_serializer;
#line 371 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_number;
#line 371 "../src/math-converter.vala"
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 371 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 371 "../src/math-converter.vala"
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
#line 371 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 2739 "math-converter.c"
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 375 "../src/math-converter.vala"
		_tmp13_ = self->priv->from_entry;
#line 375 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 375 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 375 "../src/math-converter.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 375 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 375 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 375 "../src/math-converter.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 375 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 375 "../src/math-converter.vala"
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
#line 375 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 375 "../src/math-converter.vala"
		self->priv->from_number = _tmp21_;
#line 375 "../src/math-converter.vala"
		_g_free0 (_tmp20_);
#line 375 "../src/math-converter.vala"
		_g_free0 (_tmp18_);
#line 376 "../src/math-converter.vala"
		_tmp22_ = self->priv->from_number;
#line 376 "../src/math-converter.vala"
		if (_tmp22_ == NULL) {
#line 2790 "math-converter.c"
			Number* _tmp23_;
#line 377 "../src/math-converter.vala"
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 377 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->from_number);
#line 377 "../src/math-converter.vala"
			self->priv->from_number = _tmp23_;
#line 2798 "math-converter.c"
		}
#line 378 "../src/math-converter.vala"
		_tmp24_ = self->priv->from_entry;
#line 378 "../src/math-converter.vala"
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
#line 378 "../src/math-converter.vala"
		_tmp26_ = _tmp25_;
#line 378 "../src/math-converter.vala"
		_tmp27_ = self->priv->_equation;
#line 378 "../src/math-converter.vala"
		_tmp28_ = math_equation_get_serializer (_tmp27_);
#line 378 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 378 "../src/math-converter.vala"
		_tmp30_ = self->priv->from_number;
#line 378 "../src/math-converter.vala"
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
#line 378 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 378 "../src/math-converter.vala"
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
#line 378 "../src/math-converter.vala"
		_g_free0 (_tmp32_);
#line 2822 "math-converter.c"
	}
#line 380 "../src/math-converter.vala"
	_tmp33_ = self->priv->from_entry;
#line 380 "../src/math-converter.vala"
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
#line 380 "../src/math-converter.vala"
	_tmp35_ = _tmp34_;
#line 380 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp35_, self->priv->from_entry_changed);
#line 2832 "math-converter.c"
}

static void
_math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_from_entry_focus_cb ((MathConverter*) self);
#line 2842 "math-converter.c"
}

static void
math_converter_to_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp33_;
	GtkTextBuffer* _tmp34_;
	GtkTextBuffer* _tmp35_;
#line 384 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 386 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 386 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 386 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->to_entry_changed);
#line 387 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_entry;
#line 387 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 387 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 387 "../src/math-converter.vala"
	if (_tmp5_) {
#line 2875 "math-converter.c"
		GtkTextView* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		Serializer* _tmp9_;
		Number* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 389 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 389 "../src/math-converter.vala"
		_tmp7_ = gtk_text_view_get_buffer (_tmp6_);
#line 389 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 389 "../src/math-converter.vala"
		_tmp9_ = self->priv->fixed_serializer;
#line 389 "../src/math-converter.vala"
		_tmp10_ = self->priv->to_number;
#line 389 "../src/math-converter.vala"
		_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 389 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 389 "../src/math-converter.vala"
		g_object_set (_tmp8_, "text", _tmp12_, NULL);
#line 389 "../src/math-converter.vala"
		_g_free0 (_tmp12_);
#line 2901 "math-converter.c"
	} else {
		GtkTextView* _tmp13_;
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		MathEquation* _tmp27_;
		Serializer* _tmp28_;
		Serializer* _tmp29_;
		Number* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 393 "../src/math-converter.vala"
		_tmp13_ = self->priv->to_entry;
#line 393 "../src/math-converter.vala"
		_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 393 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 393 "../src/math-converter.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 393 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 393 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 393 "../src/math-converter.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 393 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 393 "../src/math-converter.vala"
		_tmp21_ = math_converter_get_number_from_string (self, _tmp20_);
#line 393 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 393 "../src/math-converter.vala"
		self->priv->to_number = _tmp21_;
#line 393 "../src/math-converter.vala"
		_g_free0 (_tmp20_);
#line 393 "../src/math-converter.vala"
		_g_free0 (_tmp18_);
#line 394 "../src/math-converter.vala"
		_tmp22_ = self->priv->to_number;
#line 394 "../src/math-converter.vala"
		if (_tmp22_ == NULL) {
#line 2952 "math-converter.c"
			Number* _tmp23_;
#line 395 "../src/math-converter.vala"
			_tmp23_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 395 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->to_number);
#line 395 "../src/math-converter.vala"
			self->priv->to_number = _tmp23_;
#line 2960 "math-converter.c"
		}
#line 396 "../src/math-converter.vala"
		_tmp24_ = self->priv->to_entry;
#line 396 "../src/math-converter.vala"
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
#line 396 "../src/math-converter.vala"
		_tmp26_ = _tmp25_;
#line 396 "../src/math-converter.vala"
		_tmp27_ = self->priv->_equation;
#line 396 "../src/math-converter.vala"
		_tmp28_ = math_equation_get_serializer (_tmp27_);
#line 396 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 396 "../src/math-converter.vala"
		_tmp30_ = self->priv->to_number;
#line 396 "../src/math-converter.vala"
		_tmp31_ = serializer_to_string (_tmp29_, _tmp30_);
#line 396 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 396 "../src/math-converter.vala"
		g_object_set (_tmp26_, "text", _tmp32_, NULL);
#line 396 "../src/math-converter.vala"
		_g_free0 (_tmp32_);
#line 2984 "math-converter.c"
	}
#line 398 "../src/math-converter.vala"
	_tmp33_ = self->priv->to_entry;
#line 398 "../src/math-converter.vala"
	_tmp34_ = gtk_text_view_get_buffer (_tmp33_);
#line 398 "../src/math-converter.vala"
	_tmp35_ = _tmp34_;
#line 398 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp35_, self->priv->to_entry_changed);
#line 2994 "math-converter.c"
}

static void
_math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_entry_focus_cb ((MathConverter*) self);
#line 3004 "math-converter.c"
}

static void
math_converter_from_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GtkTextView* _tmp39_;
	GtkTextBuffer* _tmp40_;
	GtkTextBuffer* _tmp41_;
#line 401 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 403 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 403 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 403 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 403 "../src/math-converter.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 403 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 403 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 403 "../src/math-converter.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 403 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 403 "../src/math-converter.vala"
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
#line 403 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 403 "../src/math-converter.vala"
	self->priv->from_number = _tmp8_;
#line 403 "../src/math-converter.vala"
	_g_free0 (_tmp7_);
#line 403 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 404 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_number;
#line 404 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 3068 "math-converter.c"
		Number* _tmp10_;
#line 405 "../src/math-converter.vala"
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 405 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 405 "../src/math-converter.vala"
		self->priv->from_number = _tmp10_;
#line 3076 "math-converter.c"
	}
#line 407 "../src/math-converter.vala"
	_tmp11_ = self->priv->from_number;
#line 407 "../src/math-converter.vala"
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
#line 407 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 407 "../src/math-converter.vala"
	source_unit = _tmp12_;
#line 407 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 407 "../src/math-converter.vala"
	target_unit = _tmp13_;
#line 407 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 407 "../src/math-converter.vala"
	self->priv->to_number = _tmp14_;
#line 408 "../src/math-converter.vala"
	_tmp15_ = self->priv->to_number;
#line 408 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 3098 "math-converter.c"
		Number* _tmp16_;
#line 409 "../src/math-converter.vala"
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 409 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 409 "../src/math-converter.vala"
		self->priv->to_number = _tmp16_;
#line 3106 "math-converter.c"
	}
#line 410 "../src/math-converter.vala"
	_tmp17_ = self->priv->to_entry;
#line 410 "../src/math-converter.vala"
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 410 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 410 "../src/math-converter.vala"
	g_signal_handler_block (_tmp19_, self->priv->to_entry_changed);
#line 411 "../src/math-converter.vala"
	_tmp20_ = self->priv->to_entry;
#line 411 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp20_, "has-focus", &_tmp21_, NULL);
#line 411 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 411 "../src/math-converter.vala"
	if (_tmp22_) {
#line 3124 "math-converter.c"
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
		Serializer* _tmp26_;
		Number* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 412 "../src/math-converter.vala"
		_tmp23_ = self->priv->to_entry;
#line 412 "../src/math-converter.vala"
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 412 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 412 "../src/math-converter.vala"
		_tmp26_ = self->priv->fixed_serializer;
#line 412 "../src/math-converter.vala"
		_tmp27_ = self->priv->to_number;
#line 412 "../src/math-converter.vala"
		_tmp28_ = serializer_to_string (_tmp26_, _tmp27_);
#line 412 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 412 "../src/math-converter.vala"
		g_object_set (_tmp25_, "text", _tmp29_, NULL);
#line 412 "../src/math-converter.vala"
		_g_free0 (_tmp29_);
#line 3150 "math-converter.c"
	} else {
		GtkTextView* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextBuffer* _tmp32_;
		MathEquation* _tmp33_;
		Serializer* _tmp34_;
		Serializer* _tmp35_;
		Number* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 414 "../src/math-converter.vala"
		_tmp30_ = self->priv->to_entry;
#line 414 "../src/math-converter.vala"
		_tmp31_ = gtk_text_view_get_buffer (_tmp30_);
#line 414 "../src/math-converter.vala"
		_tmp32_ = _tmp31_;
#line 414 "../src/math-converter.vala"
		_tmp33_ = self->priv->_equation;
#line 414 "../src/math-converter.vala"
		_tmp34_ = math_equation_get_serializer (_tmp33_);
#line 414 "../src/math-converter.vala"
		_tmp35_ = _tmp34_;
#line 414 "../src/math-converter.vala"
		_tmp36_ = self->priv->to_number;
#line 414 "../src/math-converter.vala"
		_tmp37_ = serializer_to_string (_tmp35_, _tmp36_);
#line 414 "../src/math-converter.vala"
		_tmp38_ = _tmp37_;
#line 414 "../src/math-converter.vala"
		g_object_set (_tmp32_, "text", _tmp38_, NULL);
#line 414 "../src/math-converter.vala"
		_g_free0 (_tmp38_);
#line 3183 "math-converter.c"
	}
#line 415 "../src/math-converter.vala"
	_tmp39_ = self->priv->to_entry;
#line 415 "../src/math-converter.vala"
	_tmp40_ = gtk_text_view_get_buffer (_tmp39_);
#line 415 "../src/math-converter.vala"
	_tmp41_ = _tmp40_;
#line 415 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp41_, self->priv->to_entry_changed);
#line 401 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 401 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 3197 "math-converter.c"
}

static void
math_converter_to_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp11_;
	Unit* _tmp12_ = NULL;
	Unit* _tmp13_ = NULL;
	Number* _tmp14_;
	Number* _tmp15_;
	GtkTextView* _tmp17_;
	GtkTextBuffer* _tmp18_;
	GtkTextBuffer* _tmp19_;
	GtkTextView* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextBuffer* _tmp22_;
	MathEquation* _tmp23_;
	Serializer* _tmp24_;
	Serializer* _tmp25_;
	Number* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
#line 418 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 420 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 420 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 420 "../src/math-converter.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 420 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 420 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 420 "../src/math-converter.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 420 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 420 "../src/math-converter.vala"
	_tmp8_ = math_converter_get_number_from_string (self, _tmp7_);
#line 420 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 420 "../src/math-converter.vala"
	self->priv->to_number = _tmp8_;
#line 420 "../src/math-converter.vala"
	_g_free0 (_tmp7_);
#line 420 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 421 "../src/math-converter.vala"
	_tmp9_ = self->priv->to_number;
#line 421 "../src/math-converter.vala"
	if (_tmp9_ == NULL) {
#line 3267 "math-converter.c"
		Number* _tmp10_;
#line 422 "../src/math-converter.vala"
		_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 422 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 422 "../src/math-converter.vala"
		self->priv->to_number = _tmp10_;
#line 3275 "math-converter.c"
	}
#line 424 "../src/math-converter.vala"
	_tmp11_ = self->priv->to_number;
#line 424 "../src/math-converter.vala"
	_tmp14_ = math_converter_convert_equation (self, _tmp11_, &_tmp12_, &_tmp13_);
#line 424 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 424 "../src/math-converter.vala"
	source_unit = _tmp12_;
#line 424 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 424 "../src/math-converter.vala"
	target_unit = _tmp13_;
#line 424 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 424 "../src/math-converter.vala"
	self->priv->from_number = _tmp14_;
#line 425 "../src/math-converter.vala"
	_tmp15_ = self->priv->from_number;
#line 425 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 3297 "math-converter.c"
		Number* _tmp16_;
#line 426 "../src/math-converter.vala"
		_tmp16_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 426 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 426 "../src/math-converter.vala"
		self->priv->from_number = _tmp16_;
#line 3305 "math-converter.c"
	}
#line 427 "../src/math-converter.vala"
	_tmp17_ = self->priv->from_entry;
#line 427 "../src/math-converter.vala"
	_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 427 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 427 "../src/math-converter.vala"
	g_signal_handler_block (_tmp19_, self->priv->from_entry_changed);
#line 428 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_entry;
#line 428 "../src/math-converter.vala"
	_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 428 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 428 "../src/math-converter.vala"
	_tmp23_ = self->priv->_equation;
#line 428 "../src/math-converter.vala"
	_tmp24_ = math_equation_get_serializer (_tmp23_);
#line 428 "../src/math-converter.vala"
	_tmp25_ = _tmp24_;
#line 428 "../src/math-converter.vala"
	_tmp26_ = self->priv->from_number;
#line 428 "../src/math-converter.vala"
	_tmp27_ = serializer_to_string (_tmp25_, _tmp26_);
#line 428 "../src/math-converter.vala"
	_tmp28_ = _tmp27_;
#line 428 "../src/math-converter.vala"
	g_object_set (_tmp22_, "text", _tmp28_, NULL);
#line 428 "../src/math-converter.vala"
	_g_free0 (_tmp28_);
#line 429 "../src/math-converter.vala"
	_tmp29_ = self->priv->from_entry;
#line 429 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 429 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 429 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp31_, self->priv->from_entry_changed);
#line 418 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 418 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 3349 "math-converter.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 3376 "math-converter.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 3382 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 3388 "math-converter.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 3392 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 3400 "math-converter.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 3404 "math-converter.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 3416 "math-converter.c"
}

static Number*
math_converter_get_number_from_string (MathConverter* self,
                                       const gchar* str)
{
	gboolean _tmp1_ = FALSE;
	Serializer* _tmp19_;
	Number* _tmp20_;
	Number* result;
#line 432 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 432 "../src/math-converter.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 434 "../src/math-converter.vala"
	if (g_strcmp0 (str, "π") == 0) {
#line 3433 "math-converter.c"
		Number* _tmp0_;
#line 435 "../src/math-converter.vala"
		_tmp0_ = number_new_pi ();
#line 435 "../src/math-converter.vala"
		result = _tmp0_;
#line 435 "../src/math-converter.vala"
		return result;
#line 3441 "math-converter.c"
	}
#line 436 "../src/math-converter.vala"
	if (g_strcmp0 (str, "−π") == 0) {
#line 436 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 3447 "math-converter.c"
	} else {
#line 436 "../src/math-converter.vala"
		_tmp1_ = g_strcmp0 (str, "-π") == 0;
#line 3451 "math-converter.c"
	}
#line 436 "../src/math-converter.vala"
	if (_tmp1_) {
#line 3455 "math-converter.c"
		Number* _tmp2_;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
#line 437 "../src/math-converter.vala"
		_tmp2_ = number_new_pi ();
#line 437 "../src/math-converter.vala"
		_tmp3_ = _tmp2_;
#line 437 "../src/math-converter.vala"
		_tmp4_ = number_invert_sign (_tmp3_);
#line 437 "../src/math-converter.vala"
		_tmp5_ = _tmp4_;
#line 437 "../src/math-converter.vala"
		_g_object_unref0 (_tmp3_);
#line 437 "../src/math-converter.vala"
		result = _tmp5_;
#line 437 "../src/math-converter.vala"
		return result;
#line 3474 "math-converter.c"
	}
#line 438 "../src/math-converter.vala"
	if (g_str_has_suffix (str, "π")) {
#line 3478 "math-converter.c"
		Number* number = NULL;
		Serializer* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
		Number* _tmp16_;
		Number* _tmp17_;
		Number* _tmp18_;
#line 440 "../src/math-converter.vala"
		_tmp6_ = self->priv->fixed_serializer;
#line 440 "../src/math-converter.vala"
		_tmp7_ = strlen ("π");
#line 440 "../src/math-converter.vala"
		_tmp8_ = _tmp7_;
#line 440 "../src/math-converter.vala"
		_tmp9_ = string_slice (str, (glong) 0, (glong) (-_tmp8_));
#line 440 "../src/math-converter.vala"
		_tmp10_ = _tmp9_;
#line 440 "../src/math-converter.vala"
		_tmp11_ = serializer_from_string (_tmp6_, _tmp10_);
#line 440 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 440 "../src/math-converter.vala"
		_g_free0 (_tmp10_);
#line 440 "../src/math-converter.vala"
		number = _tmp12_;
#line 441 "../src/math-converter.vala"
		_tmp13_ = number;
#line 441 "../src/math-converter.vala"
		if (_tmp13_ == NULL) {
#line 442 "../src/math-converter.vala"
			result = NULL;
#line 442 "../src/math-converter.vala"
			_g_object_unref0 (number);
#line 442 "../src/math-converter.vala"
			return result;
#line 3521 "math-converter.c"
		}
#line 443 "../src/math-converter.vala"
		_tmp14_ = number_new_pi ();
#line 443 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 443 "../src/math-converter.vala"
		_tmp16_ = number;
#line 443 "../src/math-converter.vala"
		_tmp17_ = number_multiply (_tmp15_, _tmp16_);
#line 443 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 443 "../src/math-converter.vala"
		_g_object_unref0 (_tmp15_);
#line 443 "../src/math-converter.vala"
		result = _tmp18_;
#line 443 "../src/math-converter.vala"
		_g_object_unref0 (number);
#line 443 "../src/math-converter.vala"
		return result;
#line 3541 "math-converter.c"
	}
#line 445 "../src/math-converter.vala"
	_tmp19_ = self->priv->fixed_serializer;
#line 445 "../src/math-converter.vala"
	_tmp20_ = serializer_from_string (_tmp19_, str);
#line 445 "../src/math-converter.vala"
	result = _tmp20_;
#line 445 "../src/math-converter.vala"
	return result;
#line 3551 "math-converter.c"
}

static gboolean
math_converter_key_press_cb (MathConverter* self,
                             GtkEventControllerKey* controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType mod_state)
{
	GdkModifierType state = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint new_keyval = 0U;
	guint32 c = 0U;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean result;
#line 449 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 449 "../src/math-converter.vala"
	g_return_val_if_fail (controller != NULL, FALSE);
#line 452 "../src/math-converter.vala"
	state = mod_state & (GDK_CONTROL_MASK | GDK_ALT_MASK);
#line 454 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Escape) {
#line 454 "../src/math-converter.vala"
		_tmp1_ = state == 0;
#line 3583 "math-converter.c"
	} else {
#line 454 "../src/math-converter.vala"
		_tmp1_ = FALSE;
#line 3587 "math-converter.c"
	}
#line 454 "../src/math-converter.vala"
	if (_tmp1_) {
#line 454 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 3593 "math-converter.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 455 "../src/math-converter.vala"
		if (keyval == GDK_KEY_Delete) {
#line 455 "../src/math-converter.vala"
			_tmp2_ = (mod_state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 3600 "math-converter.c"
		} else {
#line 455 "../src/math-converter.vala"
			_tmp2_ = FALSE;
#line 3604 "math-converter.c"
		}
#line 455 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 3608 "math-converter.c"
	}
#line 454 "../src/math-converter.vala"
	if (_tmp0_) {
#line 457 "../src/math-converter.vala"
		math_converter_clear (self);
#line 458 "../src/math-converter.vala"
		result = TRUE;
#line 458 "../src/math-converter.vala"
		return result;
#line 3618 "math-converter.c"
	}
#line 462 "../src/math-converter.vala"
	new_keyval = (guint) 0;
#line 463 "../src/math-converter.vala"
	switch (keyval) {
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Insert:
#line 3626 "math-converter.c"
		{
#line 466 "../src/math-converter.vala"
			new_keyval = GDK_KEY_0;
#line 467 "../src/math-converter.vala"
			break;
#line 3632 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_End:
#line 3636 "math-converter.c"
		{
#line 469 "../src/math-converter.vala"
			new_keyval = GDK_KEY_1;
#line 470 "../src/math-converter.vala"
			break;
#line 3642 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Down:
#line 3646 "math-converter.c"
		{
#line 472 "../src/math-converter.vala"
			new_keyval = GDK_KEY_2;
#line 473 "../src/math-converter.vala"
			break;
#line 3652 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Down:
#line 3656 "math-converter.c"
		{
#line 475 "../src/math-converter.vala"
			new_keyval = GDK_KEY_3;
#line 476 "../src/math-converter.vala"
			break;
#line 3662 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Left:
#line 3666 "math-converter.c"
		{
#line 478 "../src/math-converter.vala"
			new_keyval = GDK_KEY_4;
#line 479 "../src/math-converter.vala"
			break;
#line 3672 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Begin:
#line 3676 "math-converter.c"
		{
#line 481 "../src/math-converter.vala"
			new_keyval = GDK_KEY_5;
#line 482 "../src/math-converter.vala"
			break;
#line 3682 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Right:
#line 3686 "math-converter.c"
		{
#line 484 "../src/math-converter.vala"
			new_keyval = GDK_KEY_6;
#line 485 "../src/math-converter.vala"
			break;
#line 3692 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Home:
#line 3696 "math-converter.c"
		{
#line 487 "../src/math-converter.vala"
			new_keyval = GDK_KEY_7;
#line 488 "../src/math-converter.vala"
			break;
#line 3702 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Up:
#line 3706 "math-converter.c"
		{
#line 490 "../src/math-converter.vala"
			new_keyval = GDK_KEY_8;
#line 491 "../src/math-converter.vala"
			break;
#line 3712 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Up:
#line 3716 "math-converter.c"
		{
#line 493 "../src/math-converter.vala"
			new_keyval = GDK_KEY_9;
#line 494 "../src/math-converter.vala"
			break;
#line 3722 "math-converter.c"
		}
#line 463 "../src/math-converter.vala"
		case GDK_KEY_KP_Delete:
#line 3726 "math-converter.c"
		{
#line 496 "../src/math-converter.vala"
			new_keyval = GDK_KEY_period;
#line 497 "../src/math-converter.vala"
			break;
#line 3732 "math-converter.c"
		}
		default:
#line 463 "../src/math-converter.vala"
		break;
#line 3737 "math-converter.c"
	}
#line 500 "../src/math-converter.vala"
	if (new_keyval != ((guint) 0)) {
#line 502 "../src/math-converter.vala"
		g_info ("math-converter.vala:502: forwarding\n");
#line 503 "../src/math-converter.vala"
		result = math_converter_key_press_cb (self, controller, new_keyval, keycode, mod_state);
#line 503 "../src/math-converter.vala"
		return result;
#line 3747 "math-converter.c"
	}
#line 506 "../src/math-converter.vala"
	c = gdk_keyval_to_unicode (keyval);
#line 508 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Return) {
#line 508 "../src/math-converter.vala"
		_tmp3_ = TRUE;
#line 3755 "math-converter.c"
	} else {
#line 508 "../src/math-converter.vala"
		_tmp3_ = keyval == GDK_KEY_KP_Enter;
#line 3759 "math-converter.c"
	}
#line 508 "../src/math-converter.vala"
	if (_tmp3_) {
#line 509 "../src/math-converter.vala"
		result = TRUE;
#line 509 "../src/math-converter.vala"
		return result;
#line 3767 "math-converter.c"
	}
#line 512 "../src/math-converter.vala"
	if (keyval == GDK_KEY_KP_Decimal) {
#line 512 "../src/math-converter.vala"
		_tmp7_ = TRUE;
#line 3773 "math-converter.c"
	} else {
#line 513 "../src/math-converter.vala"
		_tmp7_ = keyval == GDK_KEY_KP_Separator;
#line 3777 "math-converter.c"
	}
#line 512 "../src/math-converter.vala"
	if (_tmp7_) {
#line 512 "../src/math-converter.vala"
		_tmp6_ = TRUE;
#line 3783 "math-converter.c"
	} else {
#line 514 "../src/math-converter.vala"
		_tmp6_ = keyval == GDK_KEY_period;
#line 3787 "math-converter.c"
	}
#line 512 "../src/math-converter.vala"
	if (_tmp6_) {
#line 512 "../src/math-converter.vala"
		_tmp5_ = TRUE;
#line 3793 "math-converter.c"
	} else {
#line 515 "../src/math-converter.vala"
		_tmp5_ = keyval == GDK_KEY_decimalpoint;
#line 3797 "math-converter.c"
	}
#line 512 "../src/math-converter.vala"
	if (_tmp5_) {
#line 512 "../src/math-converter.vala"
		_tmp4_ = TRUE;
#line 3803 "math-converter.c"
	} else {
#line 516 "../src/math-converter.vala"
		_tmp4_ = keyval == GDK_KEY_comma;
#line 3807 "math-converter.c"
	}
#line 512 "../src/math-converter.vala"
	if (_tmp4_) {
#line 518 "../src/math-converter.vala"
		math_converter_insert_numeric_point (self);
#line 519 "../src/math-converter.vala"
		result = TRUE;
#line 519 "../src/math-converter.vala"
		return result;
#line 3817 "math-converter.c"
	}
#line 523 "../src/math-converter.vala"
	if (state == 0) {
#line 3821 "math-converter.c"
		gboolean _tmp8_ = FALSE;
#line 525 "../src/math-converter.vala"
		if (c >= ((guint32) '0')) {
#line 525 "../src/math-converter.vala"
			_tmp8_ = c <= ((guint32) '9');
#line 3827 "math-converter.c"
		} else {
#line 525 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 3831 "math-converter.c"
		}
#line 525 "../src/math-converter.vala"
		if (_tmp8_) {
#line 3835 "math-converter.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 527 "../src/math-converter.vala"
			_tmp9_ = g_strdup_printf ("%c", c);
#line 527 "../src/math-converter.vala"
			_tmp10_ = _tmp9_;
#line 527 "../src/math-converter.vala"
			math_converter_insert_text (self, _tmp10_);
#line 527 "../src/math-converter.vala"
			_g_free0 (_tmp10_);
#line 528 "../src/math-converter.vala"
			result = TRUE;
#line 528 "../src/math-converter.vala"
			return result;
#line 3850 "math-converter.c"
		}
#line 530 "../src/math-converter.vala"
		if (c == ((guint32) '-')) {
#line 532 "../src/math-converter.vala"
			math_converter_insert_text (self, "−");
#line 533 "../src/math-converter.vala"
			result = TRUE;
#line 533 "../src/math-converter.vala"
			return result;
#line 3860 "math-converter.c"
		}
	}
#line 538 "../src/math-converter.vala"
	if (state == GDK_CONTROL_MASK) {
#line 538 "../src/math-converter.vala"
		_tmp11_ = keyval == GDK_KEY_p;
#line 3867 "math-converter.c"
	} else {
#line 538 "../src/math-converter.vala"
		_tmp11_ = FALSE;
#line 3871 "math-converter.c"
	}
#line 538 "../src/math-converter.vala"
	if (_tmp11_) {
#line 540 "../src/math-converter.vala"
		math_converter_insert_text (self, "π");
#line 541 "../src/math-converter.vala"
		result = TRUE;
#line 541 "../src/math-converter.vala"
		return result;
#line 3881 "math-converter.c"
	}
#line 544 "../src/math-converter.vala"
	result = FALSE;
#line 544 "../src/math-converter.vala"
	return result;
#line 3887 "math-converter.c"
}

static gboolean
_math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = math_converter_key_press_cb ((MathConverter*) self, _sender, keyval, keycode, state);
#line 12 "../src/math-converter.vala"
	return result;
#line 3901 "math-converter.c"
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
#line 550 "../src/math-converter.vala"
	return self ? gdk_event_ref (self) : NULL;
#line 3909 "math-converter.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 550 "../src/math-converter.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 3917 "math-converter.c"
}

static void
math_converter_from_entry_click_cb (MathConverter* self,
                                    GtkGestureClick* gesture,
                                    gint n_click,
                                    gdouble x,
                                    gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 548 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 548 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 550 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 550 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 550 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 550 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 550 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 550 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 550 "../src/math-converter.vala"
	event = _tmp4_;
#line 551 "../src/math-converter.vala"
	_tmp5_ = event;
#line 551 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 3956 "math-converter.c"
		GtkTextView* _tmp6_;
#line 553 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 553 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 554 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 3964 "math-converter.c"
	}
#line 548 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 3968 "math-converter.c"
}

static void
_math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_from_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 3980 "math-converter.c"
}

static void
math_converter_to_entry_click_cb (MathConverter* self,
                                  GtkGestureClick* gesture,
                                  gint n_click,
                                  gdouble x,
                                  gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 559 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 561 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 561 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 561 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 561 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 561 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 561 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 561 "../src/math-converter.vala"
	event = _tmp4_;
#line 562 "../src/math-converter.vala"
	_tmp5_ = event;
#line 562 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 4019 "math-converter.c"
		GtkTextView* _tmp6_;
#line 564 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 564 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 565 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 4027 "math-converter.c"
	}
#line 559 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 4031 "math-converter.c"
}

static void
_math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 12 "../src/math-converter.vala"
	math_converter_to_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 4043 "math-converter.c"
}

static void
math_converter_show_context_menu (MathConverter* self,
                                  GtkTextView* entry,
                                  gdouble x,
                                  gdouble y)
{
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gboolean can_paste = FALSE;
	GdkClipboard* _tmp3_;
	GdkContentFormats* _tmp4_;
	GtkRoot* _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextIter _tmp12_;
	GtkTextIter _tmp13_;
	GtkPopoverMenu* _tmp14_ = NULL;
	GtkTextView* _tmp15_;
	GtkPopoverMenu* context_menu = NULL;
	GtkPopoverMenu* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GtkPopoverMenu* _tmp23_;
#line 569 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/math-converter.vala"
	g_return_if_fail (entry != NULL);
#line 571 "../src/math-converter.vala"
	_tmp0_ = gdk_display_get_default ();
#line 571 "../src/math-converter.vala"
	_tmp1_ = gdk_display_get_clipboard (_tmp0_);
#line 571 "../src/math-converter.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 571 "../src/math-converter.vala"
	clipboard = _tmp2_;
#line 572 "../src/math-converter.vala"
	_tmp3_ = clipboard;
#line 572 "../src/math-converter.vala"
	_tmp4_ = gdk_clipboard_get_formats (_tmp3_);
#line 572 "../src/math-converter.vala"
	can_paste = gdk_content_formats_contain_gtype (_tmp4_, G_TYPE_STRING);
#line 573 "../src/math-converter.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "context-menu.paste", can_paste);
#line 574 "../src/math-converter.vala"
	_tmp5_ = gtk_widget_get_root ((GtkWidget*) self);
#line 574 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp5_, NULL);
#line 576 "../src/math-converter.vala"
	_tmp6_ = gtk_text_view_get_buffer (entry);
#line 576 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 576 "../src/math-converter.vala"
	gtk_text_buffer_get_bounds (_tmp7_, &_tmp8_, &_tmp9_);
#line 576 "../src/math-converter.vala"
	start = _tmp8_;
#line 576 "../src/math-converter.vala"
	end = _tmp9_;
#line 577 "../src/math-converter.vala"
	_tmp10_ = gtk_text_view_get_buffer (entry);
#line 577 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 577 "../src/math-converter.vala"
	_tmp12_ = start;
#line 577 "../src/math-converter.vala"
	_tmp13_ = end;
#line 577 "../src/math-converter.vala"
	gtk_text_buffer_select_range (_tmp11_, &_tmp12_, &_tmp13_);
#line 578 "../src/math-converter.vala"
	_tmp15_ = self->priv->from_entry;
#line 578 "../src/math-converter.vala"
	if (entry == _tmp15_) {
#line 4124 "math-converter.c"
		GtkPopoverMenu* _tmp16_;
#line 578 "../src/math-converter.vala"
		_tmp16_ = self->priv->from_context_menu;
#line 578 "../src/math-converter.vala"
		_tmp14_ = _tmp16_;
#line 4130 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp17_;
#line 578 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_context_menu;
#line 578 "../src/math-converter.vala"
		_tmp14_ = _tmp17_;
#line 4137 "math-converter.c"
	}
#line 578 "../src/math-converter.vala"
	_tmp18_ = _g_object_ref0 (_tmp14_);
#line 578 "../src/math-converter.vala"
	context_menu = _tmp18_;
#line 579 "../src/math-converter.vala"
	if (x != ((gdouble) -1)) {
#line 579 "../src/math-converter.vala"
		_tmp19_ = y != ((gdouble) -1);
#line 4147 "math-converter.c"
	} else {
#line 579 "../src/math-converter.vala"
		_tmp19_ = FALSE;
#line 4151 "math-converter.c"
	}
#line 579 "../src/math-converter.vala"
	if (_tmp19_) {
#line 4155 "math-converter.c"
		GtkPopoverMenu* _tmp20_;
		GdkRectangle _tmp21_ = {0};
#line 580 "../src/math-converter.vala"
		_tmp20_ = context_menu;
#line 580 "../src/math-converter.vala"
		_tmp21_.x = (gint) x;
#line 580 "../src/math-converter.vala"
		_tmp21_.y = (gint) y;
#line 580 "../src/math-converter.vala"
		_tmp21_.width = 1;
#line 580 "../src/math-converter.vala"
		_tmp21_.height = 1;
#line 580 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp20_, &_tmp21_);
#line 4170 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp22_;
#line 582 "../src/math-converter.vala"
		_tmp22_ = context_menu;
#line 582 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp22_, NULL);
#line 4177 "math-converter.c"
	}
#line 583 "../src/math-converter.vala"
	_tmp23_ = context_menu;
#line 583 "../src/math-converter.vala"
	gtk_popover_popup ((GtkPopover*) _tmp23_);
#line 569 "../src/math-converter.vala"
	_g_object_unref0 (context_menu);
#line 569 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 4187 "math-converter.c"
}

static void
math_converter_popup_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
#line 586 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 586 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 588 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 588 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 588 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 588 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4213 "math-converter.c"
		GtkTextView* _tmp4_;
#line 588 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 588 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4219 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 588 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 588 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4226 "math-converter.c"
	}
#line 588 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 588 "../src/math-converter.vala"
	entry = _tmp6_;
#line 589 "../src/math-converter.vala"
	math_converter_show_context_menu (self, entry, (gdouble) -1, (gdouble) -1);
#line 586 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 4236 "math-converter.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4258 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4262 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4268 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4272 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 4276 "math-converter.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 4284 "math-converter.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4312 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 4321 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4335 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 4344 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 4358 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 4367 "math-converter.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 4376 "math-converter.c"
}

static void
math_converter_copy_cb (MathConverter* self,
                        GSimpleAction* action,
                        GVariant* param)
{
	Number* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	Number* number = NULL;
	Number* _tmp6_;
	gchar* text = NULL;
	MathEquation* _tmp7_;
	Serializer* _tmp8_;
	Serializer* _tmp9_;
	Number* _tmp10_;
	gchar* _tmp11_;
	gchar* tsep_string = NULL;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp21_;
	GdkClipboard* _tmp22_;
	GdkClipboard* _tmp23_;
	const gchar* _tmp24_;
	GtkRoot* _tmp25_;
#line 592 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 594 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 594 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 594 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 594 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4422 "math-converter.c"
		Number* _tmp4_;
#line 594 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_number;
#line 594 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4428 "math-converter.c"
	} else {
		Number* _tmp5_;
#line 594 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_number;
#line 594 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4435 "math-converter.c"
	}
#line 594 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 594 "../src/math-converter.vala"
	number = _tmp6_;
#line 595 "../src/math-converter.vala"
	_tmp7_ = self->priv->_equation;
#line 595 "../src/math-converter.vala"
	_tmp8_ = math_equation_get_serializer (_tmp7_);
#line 595 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 595 "../src/math-converter.vala"
	_tmp10_ = number;
#line 595 "../src/math-converter.vala"
	_tmp11_ = serializer_to_string (_tmp9_, _tmp10_);
#line 595 "../src/math-converter.vala"
	text = _tmp11_;
#line 596 "../src/math-converter.vala"
	_tmp12_ = nl_langinfo (THOUSEP);
#line 596 "../src/math-converter.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 596 "../src/math-converter.vala"
	tsep_string = _tmp13_;
#line 597 "../src/math-converter.vala"
	_tmp15_ = tsep_string;
#line 597 "../src/math-converter.vala"
	if (_tmp15_ == NULL) {
#line 597 "../src/math-converter.vala"
		_tmp14_ = TRUE;
#line 4465 "math-converter.c"
	} else {
		const gchar* _tmp16_;
#line 597 "../src/math-converter.vala"
		_tmp16_ = tsep_string;
#line 597 "../src/math-converter.vala"
		_tmp14_ = g_strcmp0 (_tmp16_, "") == 0;
#line 4472 "math-converter.c"
	}
#line 597 "../src/math-converter.vala"
	if (_tmp14_) {
#line 4476 "math-converter.c"
		gchar* _tmp17_;
#line 598 "../src/math-converter.vala"
		_tmp17_ = g_strdup (" ");
#line 598 "../src/math-converter.vala"
		_g_free0 (tsep_string);
#line 598 "../src/math-converter.vala"
		tsep_string = _tmp17_;
#line 4484 "math-converter.c"
	}
#line 599 "../src/math-converter.vala"
	_tmp18_ = text;
#line 599 "../src/math-converter.vala"
	_tmp19_ = tsep_string;
#line 599 "../src/math-converter.vala"
	_tmp20_ = string_replace (_tmp18_, _tmp19_, "");
#line 599 "../src/math-converter.vala"
	_g_free0 (text);
#line 599 "../src/math-converter.vala"
	text = _tmp20_;
#line 600 "../src/math-converter.vala"
	_tmp21_ = gdk_display_get_default ();
#line 600 "../src/math-converter.vala"
	_tmp22_ = gdk_display_get_clipboard (_tmp21_);
#line 600 "../src/math-converter.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 600 "../src/math-converter.vala"
	clipboard = _tmp23_;
#line 601 "../src/math-converter.vala"
	_tmp24_ = text;
#line 601 "../src/math-converter.vala"
	gdk_clipboard_set_text (clipboard, _tmp24_);
#line 602 "../src/math-converter.vala"
	_tmp25_ = gtk_widget_get_root ((GtkWidget*) self);
#line 602 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp25_, NULL);
#line 592 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 592 "../src/math-converter.vala"
	_g_free0 (tsep_string);
#line 592 "../src/math-converter.vala"
	_g_free0 (text);
#line 592 "../src/math-converter.vala"
	_g_object_unref0 (number);
#line 4520 "math-converter.c"
}

static void
math_converter_paste_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
#line 605 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 607 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 607 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 607 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 607 "../src/math-converter.vala"
	if (_tmp3_) {
#line 4548 "math-converter.c"
		GtkTextView* _tmp4_;
#line 607 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 607 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 4554 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 607 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 607 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 4561 "math-converter.c"
	}
#line 607 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 607 "../src/math-converter.vala"
	entry = _tmp6_;
#line 608 "../src/math-converter.vala"
	_tmp7_ = gtk_text_view_get_buffer (entry);
#line 608 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 608 "../src/math-converter.vala"
	g_object_set (_tmp8_, "text", "", NULL);
#line 609 "../src/math-converter.vala"
	math_converter_paste (self);
#line 605 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 4577 "math-converter.c"
}

static void
math_converter_reformat_display (MathConverter* self)
{
	Serializer* _tmp0_;
	MathEquation* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkTextView* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTextView* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 612 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 614 "../src/math-converter.vala"
	_tmp0_ = self->priv->fixed_serializer;
#line 614 "../src/math-converter.vala"
	_tmp1_ = self->priv->_equation;
#line 614 "../src/math-converter.vala"
	_tmp2_ = math_equation_get_accuracy (_tmp1_);
#line 614 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 614 "../src/math-converter.vala"
	if (serializer_get_trailing_digits (_tmp0_) != _tmp3_) {
#line 4605 "math-converter.c"
		Serializer* _tmp4_;
		MathEquation* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 615 "../src/math-converter.vala"
		_tmp4_ = self->priv->fixed_serializer;
#line 615 "../src/math-converter.vala"
		_tmp5_ = self->priv->_equation;
#line 615 "../src/math-converter.vala"
		_tmp6_ = math_equation_get_accuracy (_tmp5_);
#line 615 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 615 "../src/math-converter.vala"
		serializer_set_trailing_digits (_tmp4_, _tmp7_);
#line 4620 "math-converter.c"
	}
#line 616 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 616 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp8_, "has-focus", &_tmp9_, NULL);
#line 616 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 616 "../src/math-converter.vala"
	if (!_tmp10_) {
#line 4630 "math-converter.c"
		GtkTextView* _tmp11_;
		GtkTextBuffer* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextView* _tmp14_;
		GtkTextBuffer* _tmp15_;
		GtkTextBuffer* _tmp16_;
		MathEquation* _tmp17_;
		Serializer* _tmp18_;
		Serializer* _tmp19_;
		Number* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GtkTextView* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextBuffer* _tmp25_;
#line 618 "../src/math-converter.vala"
		_tmp11_ = self->priv->from_entry;
#line 618 "../src/math-converter.vala"
		_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 618 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 618 "../src/math-converter.vala"
		g_signal_handler_block (_tmp13_, self->priv->from_entry_changed);
#line 619 "../src/math-converter.vala"
		_tmp14_ = self->priv->from_entry;
#line 619 "../src/math-converter.vala"
		_tmp15_ = gtk_text_view_get_buffer (_tmp14_);
#line 619 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 619 "../src/math-converter.vala"
		_tmp17_ = self->priv->_equation;
#line 619 "../src/math-converter.vala"
		_tmp18_ = math_equation_get_serializer (_tmp17_);
#line 619 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 619 "../src/math-converter.vala"
		_tmp20_ = self->priv->from_number;
#line 619 "../src/math-converter.vala"
		_tmp21_ = serializer_to_string (_tmp19_, _tmp20_);
#line 619 "../src/math-converter.vala"
		_tmp22_ = _tmp21_;
#line 619 "../src/math-converter.vala"
		g_object_set (_tmp16_, "text", _tmp22_, NULL);
#line 619 "../src/math-converter.vala"
		_g_free0 (_tmp22_);
#line 620 "../src/math-converter.vala"
		_tmp23_ = self->priv->from_entry;
#line 620 "../src/math-converter.vala"
		_tmp24_ = gtk_text_view_get_buffer (_tmp23_);
#line 620 "../src/math-converter.vala"
		_tmp25_ = _tmp24_;
#line 620 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp25_, self->priv->from_entry_changed);
#line 4684 "math-converter.c"
	}
#line 622 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_entry;
#line 622 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp26_, "has-focus", &_tmp27_, NULL);
#line 622 "../src/math-converter.vala"
	_tmp28_ = _tmp27_;
#line 622 "../src/math-converter.vala"
	if (!_tmp28_) {
#line 4694 "math-converter.c"
		GtkTextView* _tmp29_;
		GtkTextBuffer* _tmp30_;
		GtkTextBuffer* _tmp31_;
		GtkTextView* _tmp32_;
		GtkTextBuffer* _tmp33_;
		GtkTextBuffer* _tmp34_;
		MathEquation* _tmp35_;
		Serializer* _tmp36_;
		Serializer* _tmp37_;
		Number* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GtkTextView* _tmp41_;
		GtkTextBuffer* _tmp42_;
		GtkTextBuffer* _tmp43_;
#line 624 "../src/math-converter.vala"
		_tmp29_ = self->priv->to_entry;
#line 624 "../src/math-converter.vala"
		_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 624 "../src/math-converter.vala"
		_tmp31_ = _tmp30_;
#line 624 "../src/math-converter.vala"
		g_signal_handler_block (_tmp31_, self->priv->to_entry_changed);
#line 625 "../src/math-converter.vala"
		_tmp32_ = self->priv->to_entry;
#line 625 "../src/math-converter.vala"
		_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
#line 625 "../src/math-converter.vala"
		_tmp34_ = _tmp33_;
#line 625 "../src/math-converter.vala"
		_tmp35_ = self->priv->_equation;
#line 625 "../src/math-converter.vala"
		_tmp36_ = math_equation_get_serializer (_tmp35_);
#line 625 "../src/math-converter.vala"
		_tmp37_ = _tmp36_;
#line 625 "../src/math-converter.vala"
		_tmp38_ = self->priv->to_number;
#line 625 "../src/math-converter.vala"
		_tmp39_ = serializer_to_string (_tmp37_, _tmp38_);
#line 625 "../src/math-converter.vala"
		_tmp40_ = _tmp39_;
#line 625 "../src/math-converter.vala"
		g_object_set (_tmp34_, "text", _tmp40_, NULL);
#line 625 "../src/math-converter.vala"
		_g_free0 (_tmp40_);
#line 626 "../src/math-converter.vala"
		_tmp41_ = self->priv->to_entry;
#line 626 "../src/math-converter.vala"
		_tmp42_ = gtk_text_view_get_buffer (_tmp41_);
#line 626 "../src/math-converter.vala"
		_tmp43_ = _tmp42_;
#line 626 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp43_, self->priv->to_entry_changed);
#line 4748 "math-converter.c"
	}
}

void
math_converter_swap_units (MathConverter* self)
{
	Unit* from_unit = NULL;
	Unit* to_unit = NULL;
	Unit* _tmp0_ = NULL;
	Unit* _tmp1_ = NULL;
	GtkDropDown* _tmp2_;
	GtkDropDown* _tmp3_;
	GtkDropDown* _tmp4_;
	GtkDropDown* _tmp5_;
#line 630 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 633 "../src/math-converter.vala"
	math_converter_get_conversion (self, &_tmp0_, &_tmp1_);
#line 633 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 633 "../src/math-converter.vala"
	from_unit = _tmp0_;
#line 633 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 633 "../src/math-converter.vala"
	to_unit = _tmp1_;
#line 635 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_combo;
#line 635 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->from_combobox_changed);
#line 636 "../src/math-converter.vala"
	_tmp3_ = self->priv->from_combo;
#line 636 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp3_, to_unit);
#line 637 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_combo;
#line 637 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp4_, self->priv->from_combobox_changed);
#line 638 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_combo;
#line 638 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp5_, from_unit);
#line 630 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 630 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 4795 "math-converter.c"
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit** source_unit,
                                 Unit** target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkDropDown* _tmp2_;
	UnitCategory* category = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	UnitCategory* _tmp8_;
	GtkDropDown* _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	Unit* _tmp12_;
	GtkDropDown* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp15_;
	Unit* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	UnitCategory* _tmp19_;
	Number* _tmp22_;
	Number* result;
#line 641 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 641 "../src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 645 "../src/math-converter.vala"
	_tmp2_ = self->priv->category_combo;
#line 645 "../src/math-converter.vala"
	if (_tmp2_ == NULL) {
#line 645 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 4837 "math-converter.c"
	} else {
		GtkDropDown* _tmp3_;
#line 645 "../src/math-converter.vala"
		_tmp3_ = self->priv->from_combo;
#line 645 "../src/math-converter.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 4844 "math-converter.c"
	}
#line 645 "../src/math-converter.vala"
	if (_tmp1_) {
#line 645 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 4850 "math-converter.c"
	} else {
		GtkDropDown* _tmp4_;
#line 645 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_combo;
#line 645 "../src/math-converter.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 4857 "math-converter.c"
	}
#line 645 "../src/math-converter.vala"
	if (_tmp0_) {
#line 646 "../src/math-converter.vala"
		result = NULL;
#line 646 "../src/math-converter.vala"
		if (source_unit) {
#line 646 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 4867 "math-converter.c"
		} else {
#line 646 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 4871 "math-converter.c"
		}
#line 646 "../src/math-converter.vala"
		if (target_unit) {
#line 646 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 4877 "math-converter.c"
		} else {
#line 646 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 4881 "math-converter.c"
		}
#line 646 "../src/math-converter.vala"
		return result;
#line 4885 "math-converter.c"
	}
#line 647 "../src/math-converter.vala"
	_tmp5_ = self->priv->category_combo;
#line 647 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 647 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 647 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp7_) : NULL);
#line 647 "../src/math-converter.vala"
	category = _tmp8_;
#line 648 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 648 "../src/math-converter.vala"
	_tmp10_ = gtk_drop_down_get_selected_item (_tmp9_);
#line 648 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 648 "../src/math-converter.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_UNIT) ? ((Unit*) _tmp11_) : NULL);
#line 648 "../src/math-converter.vala"
	_g_object_unref0 (_vala_source_unit);
#line 648 "../src/math-converter.vala"
	_vala_source_unit = _tmp12_;
#line 649 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 649 "../src/math-converter.vala"
	_tmp14_ = gtk_drop_down_get_selected_item (_tmp13_);
#line 649 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 649 "../src/math-converter.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, TYPE_UNIT) ? ((Unit*) _tmp15_) : NULL);
#line 649 "../src/math-converter.vala"
	_g_object_unref0 (_vala_target_unit);
#line 649 "../src/math-converter.vala"
	_vala_target_unit = _tmp16_;
#line 651 "../src/math-converter.vala"
	_tmp19_ = category;
#line 651 "../src/math-converter.vala"
	if (_tmp19_ == NULL) {
#line 651 "../src/math-converter.vala"
		_tmp18_ = TRUE;
#line 4927 "math-converter.c"
	} else {
		Unit* _tmp20_;
#line 651 "../src/math-converter.vala"
		_tmp20_ = _vala_source_unit;
#line 651 "../src/math-converter.vala"
		_tmp18_ = _tmp20_ == NULL;
#line 4934 "math-converter.c"
	}
#line 651 "../src/math-converter.vala"
	if (_tmp18_) {
#line 651 "../src/math-converter.vala"
		_tmp17_ = TRUE;
#line 4940 "math-converter.c"
	} else {
		Unit* _tmp21_;
#line 651 "../src/math-converter.vala"
		_tmp21_ = _vala_target_unit;
#line 651 "../src/math-converter.vala"
		_tmp17_ = _tmp21_ == NULL;
#line 4947 "math-converter.c"
	}
#line 651 "../src/math-converter.vala"
	if (_tmp17_) {
#line 652 "../src/math-converter.vala"
		result = NULL;
#line 652 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 652 "../src/math-converter.vala"
		if (source_unit) {
#line 652 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 4959 "math-converter.c"
		} else {
#line 652 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 4963 "math-converter.c"
		}
#line 652 "../src/math-converter.vala"
		if (target_unit) {
#line 652 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 4969 "math-converter.c"
		} else {
#line 652 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 4973 "math-converter.c"
		}
#line 652 "../src/math-converter.vala"
		return result;
#line 4977 "math-converter.c"
	}
#line 653 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_number;
#line 653 "../src/math-converter.vala"
	if (x == _tmp22_) {
#line 4983 "math-converter.c"
		UnitCategory* _tmp23_;
		Unit* _tmp24_;
		Unit* _tmp25_;
		Number* _tmp26_;
#line 654 "../src/math-converter.vala"
		_tmp23_ = category;
#line 654 "../src/math-converter.vala"
		_tmp24_ = _vala_source_unit;
#line 654 "../src/math-converter.vala"
		_tmp25_ = _vala_target_unit;
#line 654 "../src/math-converter.vala"
		_tmp26_ = unit_category_convert (_tmp23_, x, _tmp24_, _tmp25_);
#line 654 "../src/math-converter.vala"
		result = _tmp26_;
#line 654 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 654 "../src/math-converter.vala"
		if (source_unit) {
#line 654 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 5004 "math-converter.c"
		} else {
#line 654 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 5008 "math-converter.c"
		}
#line 654 "../src/math-converter.vala"
		if (target_unit) {
#line 654 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 5014 "math-converter.c"
		} else {
#line 654 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 5018 "math-converter.c"
		}
#line 654 "../src/math-converter.vala"
		return result;
#line 5022 "math-converter.c"
	} else {
		UnitCategory* _tmp27_;
		Unit* _tmp28_;
		Unit* _tmp29_;
		Number* _tmp30_;
#line 656 "../src/math-converter.vala"
		_tmp27_ = category;
#line 656 "../src/math-converter.vala"
		_tmp28_ = _vala_target_unit;
#line 656 "../src/math-converter.vala"
		_tmp29_ = _vala_source_unit;
#line 656 "../src/math-converter.vala"
		_tmp30_ = unit_category_convert (_tmp27_, x, _tmp28_, _tmp29_);
#line 656 "../src/math-converter.vala"
		result = _tmp30_;
#line 656 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 656 "../src/math-converter.vala"
		if (source_unit) {
#line 656 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 5044 "math-converter.c"
		} else {
#line 656 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 5048 "math-converter.c"
		}
#line 656 "../src/math-converter.vala"
		if (target_unit) {
#line 656 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 5054 "math-converter.c"
		} else {
#line 656 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 5058 "math-converter.c"
		}
#line 656 "../src/math-converter.vala"
		return result;
#line 5062 "math-converter.c"
	}
}

MathEquation*
math_converter_get_equation (MathConverter* self)
{
	MathEquation* result;
	MathEquation* _tmp0_;
#line 14 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 14 "../src/math-converter.vala"
	result = _tmp0_;
#line 14 "../src/math-converter.vala"
	return result;
#line 5079 "math-converter.c"
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* value)
{
	MathEquation* old_value;
#line 14 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/math-converter.vala"
	old_value = math_converter_get_equation (self);
#line 14 "../src/math-converter.vala"
	if (old_value != value) {
#line 5093 "math-converter.c"
		MathEquation* _tmp0_;
#line 14 "../src/math-converter.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->_equation);
#line 14 "../src/math-converter.vala"
		self->priv->_equation = _tmp0_;
#line 14 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY]);
#line 5103 "math-converter.c"
	}
}

gboolean
math_converter_get_outer_box_visible (MathConverter* self)
{
	gboolean result;
#line 51 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/math-converter.vala"
	result = self->priv->_outer_box_visible;
#line 51 "../src/math-converter.vala"
	return result;
#line 5117 "math-converter.c"
}

void
math_converter_set_outer_box_visible (MathConverter* self,
                                      gboolean value)
{
	gboolean old_value;
#line 51 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/math-converter.vala"
	old_value = math_converter_get_outer_box_visible (self);
#line 51 "../src/math-converter.vala"
	if (old_value != value) {
#line 51 "../src/math-converter.vala"
		self->priv->_outer_box_visible = value;
#line 51 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY]);
#line 5135 "math-converter.c"
	}
}

static void
_math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 68 "../src/math-converter.vala"
	math_converter_construct_finish ((MathConverter*) self);
#line 5146 "math-converter.c"
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
#line 64 "../src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 64 "../src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 66 "../src/math-converter.vala"
	_tmp0_ = self->priv->action_group;
#line 66 "../src/math-converter.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp0_, MATH_CONVERTER_action_entries, (gint) G_N_ELEMENTS (MATH_CONVERTER_action_entries), self);
#line 67 "../src/math-converter.vala"
	_tmp1_ = self->priv->action_group;
#line 67 "../src/math-converter.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "context-menu", (GActionGroup*) _tmp1_);
#line 68 "../src/math-converter.vala"
	g_signal_connect_object ((GObject*) self, "notify::equation", (GCallback) _math_converter_construct_finish_g_object_notify, self, 0);
#line 64 "../src/math-converter.vala"
	return obj;
#line 5177 "math-converter.c"
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
#line 12 "../src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/math-converter.vala"
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_converter_get_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_math_converter_set_property;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_EQUATION_PROPERTY, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY] = g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 12 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY] = g_param_spec_boolean ("outer-box-visible", "outer-box-visible", "outer-box-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 12 "../src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CATEGORY_CHANGED_SIGNAL] = g_signal_new ("category-changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "category_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, category_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_entry));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_entry));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_context_menu));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_context_menu));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_event_controller));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_event_controller));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "category_combobox_changed_cb", G_CALLBACK(_math_converter_category_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_focus_cb", G_CALLBACK(_math_converter_from_entry_focus_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_focus_cb", G_CALLBACK(_math_converter_to_entry_focus_cb_g_object_notify));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_cb", G_CALLBACK(_math_converter_key_press_cb_gtk_event_controller_key_key_pressed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_click_cb", G_CALLBACK(_math_converter_from_entry_click_cb_gtk_gesture_click_pressed));
#line 12 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_click_cb", G_CALLBACK(_math_converter_to_entry_click_cb_gtk_gesture_click_pressed));
#line 56 "../src/math-converter.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "mathconverter");
#line 5238 "math-converter.c"
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
	GSimpleActionGroup* _tmp0_;
#line 12 "../src/math-converter.vala"
	self->priv = math_converter_get_instance_private (self);
#line 40 "../src/math-converter.vala"
	self->priv->from_combobox_changed = (gulong) 0;
#line 44 "../src/math-converter.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 44 "../src/math-converter.vala"
	self->priv->action_group = _tmp0_;
#line 51 "../src/math-converter.vala"
	self->priv->_outer_box_visible = FALSE;
#line 12 "../src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 5258 "math-converter.c"
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 12 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 14 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->_equation);
#line 16 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 17 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 18 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 35 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 44 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->action_group);
#line 12 "../src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 5281 "math-converter.c"
}

static GType
math_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
	GType math_converter_type_id;
	math_converter_type_id = g_type_register_static (gtk_grid_get_type (), "MathConverter", &g_define_type_info, 0);
	MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
	return math_converter_type_id;
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__once = 0;
	if (g_once_init_enter (&math_converter_type_id__once)) {
		GType math_converter_type_id;
		math_converter_type_id = math_converter_get_type_once ();
		g_once_init_leave (&math_converter_type_id__once, math_converter_type_id);
	}
	return math_converter_type_id__once;
}

static void
_vala_math_converter_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_object (value, math_converter_get_equation (self));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_outer_box_visible (self));
#line 12 "../src/math-converter.vala"
		break;
#line 5328 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 5334 "math-converter.c"
	}
}

static void
_vala_math_converter_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 12 "../src/math-converter.vala"
	switch (property_id) {
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_equation (self, g_value_get_object (value));
#line 12 "../src/math-converter.vala"
		break;
#line 12 "../src/math-converter.vala"
		case MATH_CONVERTER_OUTER_BOX_VISIBLE_PROPERTY:
#line 12 "../src/math-converter.vala"
		math_converter_set_outer_box_visible (self, g_value_get_boolean (value));
#line 12 "../src/math-converter.vala"
		break;
#line 5360 "math-converter.c"
		default:
#line 12 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/math-converter.vala"
		break;
#line 5366 "math-converter.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

